/*
 * ship.h
 *
 * things having to do with ships
 *
 * from PSL Empire, 1985
 * $Revision: 1.1 $ $Date: 89/12/12 17:00:32 $
 */

#include "nsc.h"
#include "class.h"

/* bit masks for the autonav mode flags */

#define AN_AUTONAV  1
#define AN_STANDBY  2

/* list of orders to perform for each ship */

#define ORDER_CANCEL 1
#define ORDER_STOP   2
#define ORDER_RESUME 3
#define ORDER_P      4
#define ORDER_ETA    5

#define MAXSHPV	12
#define	MAXMCHV 12

struct	shpstr {
	coord	shp_x;		/* x location in abs coords */
	coord	shp_y;		/* y location in abs coords */
	natid   shp_own;	/* owner's country num */
	char    shp_type;	/* ship type */
	char    shp_effic;	/* 0% to 100% */
	char    shp_mobil;	/* mobility units */
	short	shp_sell;	/* pointer to trade file */
	short	shp_tech;	/* tech level ship was built at */
	short	shp_uid;	/* unit id (ship #) */
	char    shp_fleet;	/* group membership */
	char	shp_name[NS_NSIZE]; /* ship name */
	char	shp_convoy;     /* convoy membership */
	char    shp_nplane;	/* number of planes/missiles on board */
	char    shp_ntank;      /* number of tanks/vehicles on board */
	char	shp_depth;	/* submarine depth: 0, 1, or 2 */
	char	shp_spare1;
	short	shp_air;	/* submarine air remaining */
	coord	shp_destx;	/* autonav x-coords */
	coord	shp_desty;	/* autonav y-coords */
	u_char	shp_autonav;	/* autonav flags */
	short	shp_aboard;	/* id of ship carrying this vehicle (or -1) */
	char	shp_odom;	/* fuel usage odometer */
	char    shp_nv;		/* current number of variables */
	u_char	shp_vtype[MAXSHPV];
	u_short	shp_vamt[MAXSHPV];
};

struct	mchrstr {
    int		m_class;        /* vehicle classification */
    int		m_lcm;		/* units of lcm to build */
    int		m_hcm;		/* units of hcm to build */
    int		m_armor;	/* how well armored it is */
    int		m_speed;	/* how fast it can go */
    int		m_visib;	/* how well it can be seen */
    int		m_vrnge;	/* how well it can see */
    int		m_frnge;	/* how far it can fire */
    int		m_glim;		/* how many guns it can fire */
    char 	*m_name;	/* full name of type of ship */
    int		m_tech;		/* tech required to build */
    int		m_cost;		/* how much it costs to build */
    int		m_flags;	/* what special things can this ship do */
    int		m_mpg;		/* miles per gallon factor */
    short	m_maxair;	/* max amt of air sub can hold */
    int		m_maxtnks;	/* max tanks/vehicles it can carry */
    int		m_maxplns;	/* max planes/missiles it can carry */
    char	*m_terrain;	/* terrain restriction string */
    u_char 	m_nv;		/* number of variables it can hold */
    u_char 	m_vtype[MAXMCHV];
    u_short 	m_vamt[MAXMCHV];
};

#define M_FOOD		bit(0)	/* catch that fish! */
#define M_TORP		bit(1)	/* fire torpedoes */
#define M_DCH		bit(2)	/* drop depth charges on subs */
#define M_FLY		bit(3)	/* launch and recover planes/vtol/heli */
#define M_MSL		bit(4)	/* launch missiles */
#define M_OIL		bit(5)	/* drill for oil */
#define M_SONAR		bit(6)	/* locate submarines */
#define M_MINE		bit(7)	/* drop mines */
#define M_SWEEP		bit(8)	/* clean up the mines */
#define M_SUB		bit(9)	/* a submarine */
#define M_SPY		bit(10)	/* gather intelligence info */
#define M_LAND		bit(11)	/* allows full landing ability */
#define M_ATV           bit(12) /* atv capability */
#define M_VTOL          bit(13) /* launch and recover vtol/heli */
#define M_HELI		bit(14) /* launch and recover helicopters only */
#define M_TAC		bit(15) /* transport disassembled aircraft/missiles */

#define getship(n, p) \
	ef_nbread(EF_SHIP, n, (caddr_t)p)
#define putship(n, p) \
	ef_nbwrite(EF_SHIP, n, (caddr_t)p)
#define seekship(n) \
        ef_seek(EF_SHIP, n)
#define getshipp(n) \
	(struct shpstr *) ef_ptr(EF_SHIP, n)

extern	double seagun();

extern  struct mchrstr mchr[];
extern	int shp_maxno;
