.TH Command BMAP
.SY "bmap <SECTS> [~|@|type [!!!]]"
Bmap gives you a graphic representation of all or part of the known world.
It is similar to the \*Qmap\*U command, except that while map shows you
only those sectors currently near or owned by you, bmap shows you archived 
sector information from your country's \*Qbigmap\*U database.  The bigmap
database is also the resource that makes possible such features as
autonavigation (see \*Qorder\*U) and autodistribution (see \*Qautodist\*U).
.s1
Every time Empire informs you of a sector's designation, be it one of your 
own or someone else's, the information is added to your bigmap.  This means
that every time you designate a sector, perform a map command, radar a region,
spy on a sector, overfly an area, etc., your bigmap database remembers for
you what you see.
.s1
Sectors generally show up as a designation mnemonic (see \*Qsector-types\*U),
although sectors held by other countries may appear as question marks (\*Q?\*U)
until their actual type is determined (by \*Qlookout\*U or \*Qspy\*U, for
example).  Mountains, wilderness ares, and seas appear as '^', '-' and '.' 
respectively.
.s1
The bmap command recognizes several different optional second parameters.
The '~' option lets you \*Qmark\*U and \*Qunmark\*U sectors.  If you
subsequently use the '@' option, marked sectors will show up as '@' on the
map.  Ocean sectors are automatically \*Qmarked\*U whenever you lay or 
encounter mines; ships sailing under autonav orders will automatically 
avoid marked ocean sectors.
.s1
If the second parameter is any character other than '@' or '~',
bmap will assume you want to force that character into your bigmap 
database.  You will normally be asked to confirm the change; if you 
want to avoid being asked for confirmation, specify '!!!' as the third
parameter ("DO IT NOW!!!").
.s1
Examples:
.EX bmap -9:18,-8:5
generates a 28 x 14 map based on data supplied by your bigmap database.
.NF
    ---------0000000000111111111
    9876543210123456789012345678
 -8        . . . - -             -8
 -7       . . . . - ^            -7
 -6    . . . . - - - -           -6
 -5   . . - . a a - ^ ? ? -      -5
 -4  . . . . k o ! - ^ ? ? ?     -4
 -3 . - . a h j a ^ ^ ^ ^ ^ -    -3
 -2  . . - . a a a ^ a a - - -   -2
 -1   . . . a a a b + + ^ ^ -    -1
  0  . . . m c u a a - ^ - ^     0
  1   . - . a a . a a - - ^      1
  2    - ^ ^ a a a ^ a - - ^     2
  3     - - - - - - - . . -      3
  4      ^ - - - - - ^ - -       4
  5       - ^ - - ^ - - -        5
    ---------0000000000111111111
    9876543210123456789012345678
.FI
.s1
.EX bmap -3,1 ~ !!!
toggles the mark at sector -3,1 without asking for confirmation.
.s3
See also : map, order, autonav
