.TH Concept Flightpath
All commands which fly airplanes require that you specify a flightpath.
In its simplest form, a flightpath is simply a string of standard 
empire movement directions (g, y, u, j, n, and b) terminated by an `h'.
To make specification less tedious, time consuming, and prone to error,
flightpath legs can also be autorouted by specifying waypoint and/or
destination sector coordinates.  
.s1
The flightpath string can consist of one or more normal empire path 
specifications, waypoint sector coordinates, route display (?) 
and delete (d) options, nops (;), and autorouter terrain restriction 
specifiers ([sectortypes]).  Any or all of these can be concatenated
together to form routing orders.  For example,
.NF +4

[214:251] Command : fly 57 . 2,-32
No escorts...

<0: 2,-32> ggb-5,-27;2,-26    <-- ggb,
-3,-31 to -5,-27: nbbb            then autoroute continue to -5,-27,
-5,-27 to 2,-26: jjjn             then autoroute continue to 2,-26

<11: 2,-26> ?                 <-- show accumulated path
Path so far: ggbnbbbjjjn          and autoroute terrain rules
Autoroute terrain: []             (all terrain is valid)

<11: 2,-26> [.+mf] 
Autorouting restricted to [.+mf] terrain.

<11: 2,-26> 7,-25             <-- autoroute continue to 7,-25
2,-26 to 7,-25: jjn

<14: 7,-25> ?                 <-- show accumulated path
Path so far: ggbnbbbjjjnjjn       and autorouter terrain rules
Autoroute terrain: [.+mf]         (route only over sea, +, m, and f)

<14: 7,-25> d4                <-- delete last four moves

<10: 1,-27> 2,-32             <-- autoroute continue to 2,-32
1,-27 to 2,-32: yyuuu

<15: 2,-32> h                 <-- stop
Ending sector is 2,-32

.FI
.s1
The entire above example could be concatenated into one command
(albeit an extreme example) which could then be supplied either 
on the command line as part of the fly command, or to the fly 
command's prompt.  (The semicolon delimiters are required only 
when concatenation would otherwise run together strings of digits.)
.NF +4

<0: 2,-32> ggb;-5,-27;2,-26;?;[.+mf];7,-25;?;d4;2,-32;h

.FI
