#ifndef lint
static char *RCSid = "$Header: /users/empire/EMP/empmain/common/RCS/bridgefall.c,v 1.3 89/05/28 17:41:43 emp-src Exp $";
#endif

/*
 * bridgefall.c
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "path.h"
#include "file.h"
#include "xy.h"

bridgefall(sp)
struct	sctstr *sp;
{
#ifndef FREESTANDINGBRIDGES
    register int i;
    struct sctstr sect;
    struct sctstr bh_sect;
    int	nx,ny,nnx,nny,mines;
    
    for (i = 1; i <= 6; i++) {
	nx = xnorm(sp->sct_x + diroff[i][0]);
	ny = ynorm(sp->sct_y + diroff[i][1]);
	getsect(nx, ny, &sect);
	if (unsupportedbridge(&sect)) {
	    collapse(&sect);
	    (void) putsect(&sect);
	}
    }
#endif
}

unsupportedbridge(sp)
struct sctstr *sp;
{
#ifdef FREESTANDINGBRIDGES
    return 0;
#else
    int j;
    coord nnx,nny;
    struct sctstr bh_sect;
    if (sp->sct_type != SCT_BSPAN) 
	return 0;
    for (j = 1; j <= 6; j++) {
	nnx = xnorm(sp->sct_x + diroff[j][0]);
	nny = ynorm(sp->sct_y + diroff[j][1]);
	if (nnx == sp->sct_x && nny == sp->sct_y)
	    continue;
	getsect(nnx, nny, &bh_sect);
	if (bh_sect.sct_type == SCT_BHEAD &&
	    bh_sect.sct_newtype == SCT_BHEAD &&
	    bh_sect.sct_effic >= 60)
	    break;
    }
    return (j > 6);
#endif
}

collapse(bp)
struct sctstr *bp;
{
#ifndef FREESTANDINGBRIDGES
    int mines,n,kills;
    if (bp->sct_type == SCT_BSPAN) {

	prc(bp->sct_own,
	    fmt("Crumble... SCREEEECH!  Splash! at %s\n",
		xyas(bp->sct_x, bp->sct_y, bp->sct_own)));

	/* Turn sector into water */
	bp->sct_type = SCT_WATER;
	bp->sct_newtype = SCT_WATER;
	bp->sct_own = 0;
	bp->sct_oldown = 0;
	bp->sct_distpath = 0L;

	/* Save only the mines; zero the rest of the commodities. */
	mines = getvar(V_MINE, (caddr_t)bp, EF_SECTOR);
	bp->sct_nv = 0;
	if (mines > 0)
	    (void) putvar(V_MINE, mines, (caddr_t)bp, EF_SECTOR);

	/* Destroy any tanks, trains and planes parked on the bridge */
	sinkstuff(bp);
    }
#endif
}

