static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/constants.c,v 1.2 89/09/03 17:23:55 mr-frog Exp $";

/*
 * constglb.c
 *
 * Global constants file.  This should probably be redone.  Note that
 * the "hours" file can override some of these, so be careful.
 *
 */

#include "gamesdef.h"
#include "misc.h"
#include "xy.h"

char    *privname   = PRVNAM;	/* name of priv user */
char    *privlog    = PRVLOG;	/* logname of priv user */

int	m_m_p_d        = 1000;	/* max mins of play per day (per country) */
/* long    s_p_etu     = 1800;	/* seconds per Empire time unit */
/* int	etu_per_update = 12;	/* # of etu's to perform per update */
long    s_p_etu        = 12;	/* seconds per Empire time unit */
int	etu_per_update = 50;	/* # of etu's to perform per update */
long    adj_update     = 0;	/* update time adjustment */

int	sect_mob_max   = 127;	/* sector mobility limits */
int	sect_mob_scale = 1;	/* accumulation multiplier */
int	ship_mob_max   = 72;	/* ship mobility limits */
int	ship_mob_scale = 2;	/* accumulation multiplier */
int	plane_mob_max  = 127;	/* plane mobility limits */
int	plane_mob_scale = 1;	/* accumulation multiplier */
int	spy_mob_max = 72;	/* spy mobility limits */
int	spy_mob_scale = 2;	/* accumulation multiplier */
int	orbit_rate = 3;		/* basic orbit velocity (etu/sector) */

int	civexplore  = 1;	/* minimum civ needed to 'explore' */
double  civexploremob = 1.0;	/* min mobility used by civ 'explore' */
int	milexplore  = 1;	/* minimum mil needed to 'explore' */
double	milexploremob = 1.0;	/* min mobility used by mil 'explore' */
double	explorecost = 5.00;	/* exploration cost per sector */
double	searchcost  = 0.40;	/* cost per mil per sector to look for spies */
double	killcost    = 5.00;	/* cost to kill a spy */
double	capturecost = 100.0;	/* cost to capture a spy */

double  fgrate      = 0.12;	/* food growth rate (dt * fert) */
double  fcrate      = 0.13;	/* food cultivate rate (dt * workforce) */
/* double  eatrate     = 0.0010;   /* food eating rate (dt * people) */
/* double  babyeat     = 0.0100;   /* food to mature 1 baby into a civilian */

double  eatrate     = 0.0001;	/* food eating rate (dt * people) */
double  babyeat     = 0.0001;	/* food to mature 1 baby into a civilian */

double  obrate      = 0.005;	/* other sectors birth rate */
double	uwbrate     = 0.0025;	/* uncompensated worker birth rate */
				/* values > 0.25 for either will overflow */

double  bankint     = 0.20;	/* bank interest rate (dt * bars) */

double	minmult     = 0.5;	/* minimum trade multiple */

u_char 	wastetime   = 254;	/* Average number of updates before wasteland 
				   reverts back to wilderness.  Range 0-255,
				   but there are three special values:
				   * 0 will cause wasteland to revert back 
				     immediately at the next update;
				   * 254 will generate random delays of 
				     between 5 and 30 updates;
				   * 255 will cause wasteland to never
				     revert back to wilderness; */

/* money gained from taxes, paid to military, and reservists */
double	money_civ  = 0.0083333;   /* Civ taxes per etu */
double	money_uw   = 0.0037777;   /* UW taxes per etu */
double	money_mil  = -0.0833333;  /* Military pay per etu */
double	money_res  = -0.0083333;  /* Military reserve pay per etu */
double	money_spy  = -0.1111111;  /* Spy pay per etu */
double  flight_pay = 5.0;    	  /* Flight pay is 5x normal military pay */
short	spy_retire = 2800;	  /* Mandatory retirement age (etus) */
double  retire_pay = 1000.0;      /* Spy retirement pension */
double	learn_rate = 1.0;         /* Rate at which spies learn to fly */

/* pct cost per ETU for maintaining a ship, plane, or spy */
double	money_plane	= -0.001;
double	money_ship	= -0.001;

/* edu and hap consumption factors -- hap_cons civs need 1 hap --> hlev++ */
double	hap_cons        = 5000.0;
double	edu_cons        = 4000.0;

/* hap and edu avg mean that the weight on current happiness is
 *  (cur_hap * hap_avg + hap_prod * etu) / (hap_avg + etu);  		*/
float   hap_avg = 48.0 * 1.0;
float   edu_avg = 48.0 * 4.0;


/* tech build limitations.  Tech limits only apply after easy_tech.
 * Two ways of limiting tech: asymptotic or logrithmic:
 * tech_hard is asymptopic limitation, tech_log_base is the logrithmic
 * limitation.  set tech_log_base > 1.0 to have it take effect,
 * set hard_tech > 0 to have it take effect
 * for log based, only tech values where the slop is < 1 are used	*/

float	easy_tech = 1.0;	/* amount of tech built with no penality */
float	hard_tech = 1.0;	/* amount of in-efficiently built tech */
/* float tech_log_base = 2.0;	/* base of log to take of in-efficient tech */
float   tech_log_base = 1.35;	/* base of log to take of in-efficient tech */

/* float   ally_factor = 20.0;	/* shared tech with allies = 1/factor */
float   ally_factor = 7.0;	/* shared tech with allies = 1/factor */
float	level_age_rate = 96.0;	/* 1% per 96 etu's; 0 -> no decline */

int	players_at_00 = 0;	/* players coord system on deity 0,0? */
int	at_least_one_100 = 1;	/* init player with 100/100/100/100 sector? */

float	btu_build_rate = 0.0004;/* etu * civ * eff * btu_build_rate */
				/* 8 * 999 * 100 * 0.0004 = 319 */
int	max_btus = 512;		/* maximum # of btu's */
double  min_btus_per_etu = 1.0; /* guarantee at least this many btus/etu */
double	powe_cost = 10.0;	/* btu cost to gen a power report */

double	buil_bt = 20.0;		/* tech level required to build a bridge */
int	buil_bh = 250;		/* hcm required to build a bridge */
double	buil_bc = 5000.0;	/* cash required to build a bridge */

double  nuke_cost_multiplier = 3.0;  /* basic nuke dollar cost multiplier */
double  nuke_tech_multiplier = 1.5;  /* basic nuke tech cost multiplier */
double  plane_cost_multiplier = 1.0; /* basic plane dollar cost multiplier */
double  plane_tech_multiplier = 1.0; /* basic plane tech cost multiplier */
double  ship_cost_multiplier = 1.0;  /* basic ship dollar cost multiplier */
double  ship_tech_multiplier = 1.0;  /* basic ship tech cost multiplier */
double  spy_cost_multiplier  = 1.0;  /* basic spy dollar cost multiplier */
double  spy_tech_multiplier  = 1.0;  /* basic spy tech cost multiplier */


/*
**  Education ratio beyond which one country can capture another country's 
**  nukes.  Set negative to make nukes uncapturable, 0 to make them always 
**  capturable, 2 to capture them only if the assailant is twice as smart 
**  as the current owner, etc.
*/

int eduratio = 2;

/*
**  These let you tune the odds of paratroop assault victory.  The victory
**  odds equation is derived as follows.  The bonus equation drives the odds;
**  bonuses for defending capitols and forts are multiplied by additional
**  constants for increased defense.  If the bonus calculates out to less
**  than paradef_minb, paradef_minb will be the value used.
**          
**    bonus = paradef_base + ( paradef_mult * SectDefFact * SectEffic/100 )
**    odds =  Paratroops / ( bonus * (GroundMil+Paratroops) )
*/

double paradef_mult = 2.5;  /* 'para' defense bonus scalar */
double paradef_base = 0.5;  /* 'para' defense bonus base */
double paradef_minb = 3.0;  /* 'para' defense minimum bonus */
double paradef_capi = 8.0;  /* 'para' capitol defense multiplier */
double paradef_fort = 4.0;  /* 'para' fort defense multiplier */

/* here the damage factor will be roll(range)+base */
int    flak_range  = 10;    /* flak random number spread */
int    flak_base   = 5;     /* flak random number base */
double flak_factor = 2.2;   /* flak intensity factor */

double effbomb_mult = 0.88; /* efficiency bombing multiplier (was 0.88) */
double effbomb_subt = 0.00; /* efficiency bombing decrement (was 0.00) */

/* here the damage factor will be roll(range)+base */
int    pinbomb_range = 6;   /* pin bomb commodity random number spread */
int    pinbomb_base  = 4;   /* pin bomb commodity random number base */

double bunker_strength = 1.5; /* bunker damage = normal damage/1.5 */
double bunker_cost  = 2.00;   /* dollar cost to increase bunker size by 1 */
double crate_cost   = 0.10;   /* fraction of original plane build cost */

double mountain_range= 1.1;      /* firing range for mountains */
double nonfort_range = 0.6;      /* firing range for othernon-forts */

int    fire_mob_cost = 1;       /* mob cost per shot fired from a ship */
double revert_water_odds = 0.05; /* chance of wasteland reverting to water */

int    sub_hullair     = 50;    /* base amount of air in submarine hull   */
int    sub_refill_rate = 500;   /* airtank refill rate in units per etu */
int    bal_refill_rate = 100;   /* balloon refill rate in units per etu */
double sub_slowdown    = 2.0;	/* mob penalty factor for submerged subs */
