static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/news.c,v 1.1 89/09/02 18:30:16 mr-frog Exp $";

/*
 * news.c
 *
 * News item characteristics; one entry (and two different
 * strings) per news item.  Be sure and increase N_MAX_VERB
 * in news.h if you add a news item.
 *
 * Order must correspond to ordering in news.h
 * 
 */

#include "misc.h"
#include "news.h"

struct  rptstr rpt[N_MAX_VERB+1] = {
/*     nice    page    text */
/*00*/    0,      3,   "does nothing in particular to %s",
  		       "does nothing to %s",
/*01*/    -4,     1,   "infantry capture %s territory",
		       "shock troops overrun one of %s's sectors",
/*02*/    -4,     1,   "infantry beaten back by %s troops",
		       "shock troops annihilated in failed attack on %s",
/*03*/    -1,     2,   "spy shot by %s firing squad",
		       "spy captured and shot by %s",
/*04*/    1,      2,   "sends a telegram to %s",
		       "telexes %s",
/*05*/    3,      3,   "diplomats sign a treaty with %s",
		       "ambassador agrees to a treaty with %s",
/*06*/    2,      3,   "bankers make a loan to %s",
		       "Ministry of Finance lends money to %s",
/*07*/    1,      3,   "repays a loan from %s",
		       "makes last payment on loan from %s",
/*08*/    0,      3,   "makes a sale to %s",
		       "sells goods to %s",
/*09*/    -1,     1,   "violates %s airspace",
		       "overflies %s territory",
/*10*/    -2,     1,   "gunners bombard %s territory",
		       "artillery fires on %s sectors",
/*11*/    -2,     1,   "shells a ship owned by %s",
		       "fires on %s ships",
/*12*/    0,      2,   "takes over unoccupied land",
		       "attacks unowned land for some reason",
/*13*/    0,      1,   "ships torpedoed by enemy wolf-packs",
		       "ships torpedoed by marauding U-boats",
/*14*/    0,      1,   "gunners fire on %s in self-defense",
		       "gunners decimate %s aggressors",
/*15*/    0,      2,   "breaks sanctuary",
		       "no longer has a sanctuary",
/*16*/    -2,     1,   "planes divebomb one of %s's sectors",
		       "bombers wreak havoc on %s",
/*17*/    -2,     1,   "divebombs a ship flying the flag of %s",
		       "airforce bombs %s ships",
/*18*/    -2,     1,   "seadogs board one of %s's ships",
		       "pirates board %s ship",
/*19*/    -3,     1,   "is repelled by %s while attempting to board a ship",
		       "pirates prove inept at boarding %s's ships",
/*20*/    -1,     1,   "anti-aircraft gunners fire on %s airforce",
		       "attempts to shoot down %s aircraft",
/*21*/    -2,     3,   "seizes a sector from %s to collect on a loan",
		       "collects one of %s's sectors in repayment of a loan",
/*22*/    -1,     2,   "considers an action which would violate a treaty with %s",
		       "decides not to violate treaty with %s (yet)",
/*23*/    -4,     1,   "violates a treaty with %s",
		       "actions violate treaty with %s",
/*24*/    0,      1,   "dissolves its government",
		       "throws in the towel",
/*25*/    0,      1,   "ship hits a mine",
		       "ship severely damaged in mine field",
/*26*/    5,      1,   "announces an alliance with %s",
		       "/ %s alliance declared",
/*27*/    0,      1,   "declares their neutrality toward %s", /* no longer used */
		       "announces neutral relations with %s",
/*28*/    -5,     1,   "declares TOTAL WAR on %s",
		       "gets serious with %s and declares WAR",
/*29*/    -5,     1,   "diplomats disavow former alliance with %s",
		       "is no longer allied with %s",
/*30*/    5,      1,   "is no longer at war with %s",
		       "Foreign Ministry declares \"No more war with %s\"",
/*31*/    0,      1,   "reports outbreak of the black plague",
		       "sector infected with bubonic plague",
/*32*/    0,      2,   "citizens die from bubonic plague",
		       "sector reports plague deaths",
/*33*/    0,      2,   "goes through a name change",
		       "adopts a new country name",
/*34*/    0,      2,   "citizens starve in disastrous famine",
		       "loses citizens to mass starvation",
/*35*/    0,      2,   "endures lawless rioting",
		       "suffers from outbreaks of rioting",
/*36*/    -3,     1,   "pilots down %s planes",
		       "victorious in air-to-air combat against %s",
/*37*/    -10,    1,   "nuclear device devastates %s sector",
		       "explodes a nuclear device damaging %s territory",
/*38*/    0,      1,   "terrorists shoot it out with %s special forces",
		       "underground rises up against %s occupation",
/*39*/    -2,     1,   "execution squads gun down helpless %s civilians",
		       "firing squads massacre defenseless %s workers",
/*40*/     0,     1,   "launches a satellite into orbit",
		       "continues its conquest of space with a successful launch",
/*41*/    -8,     1,   "strikes a %s big bird",
		       "rockets damage a %s satellite",
/*42*/     4,     1,   "makes a contribution to %s",
		       "helps out %s",
/*43*/     2,     1,   "aids %s with divine intervention",
		       "smiles upon %s",
/*44*/    -3,     1,   "hurts %s with divine intervention",
		       "frowns upon %s",
/*45*/    -4,     1,   "sacrifices to %s",
		       "makes divine payment to %s",
/*46*/    -2,     1,   "soldiers capture %s tank",
		       "absconds with %s tank",
/*47*/    -2,     1,   "cunning nets %s airship",
		       "sky pirates capture %s airship",
/*48*/    -3,     1,   "bungles plan to capture %s airship",
		       "fails attempted sky piracy",
/*49*/    -2,     1,   "shells one of %s's tanks",
		       "fires on %s tanks",
/*50*/    -2,     1,   "divebombs %s tanks",
		       "planes target %s tanks",
/*51*/    -2,     1,   "shells zero in on %s airship",
		       "artillery fires on %s airships",
/*52*/    -2,     1,   "pilots attempt to down %s balloons",
		       "planes attack %s airship",
/*53*/    -2,     1,   "shells %s train",
                       "guns fire on %s railway",
/*54*/    -2,     1,   "pilots target %s trains",
                       "bombers strike %s railway",
/*55*/    -2,     1,   "hijacks %s train",
                       "soldiers commandeer %s train",
/*56*/    -2,     1,   "tries, and fails, to take %s train",
		       "would-be hijackers bungle %s train theft",
/*57*/    -3,     1,   "fails assault on %s",
		       "assault attempt crushed by %s troops",
/*58*/    -4,     1,   "tanks capture %s land",
		       "tanks claim %s sector",
/*59*/    -4,     1,   "tank assault foiled by %s",
		       "tanks bungle raid on %s",
/*60*/    -4,     1,   "airships snatch %s land",
		       "airships drop troops on %s",
/*61*/    -4,     1,   "raiders bungle airship assault on %s",
		       "airship crew fails to take %s sector",
/*62*/    -2,     1,   "launches pinpoint strike against %s bunkers",
		       "bombers target %s bunkers",
/*63*/    -4,     1,   "tanks roll onto %s beach",
                       "ships land tanks on %s shore",
/*64*/    -2,     1,   "sub hunters pound %s sub",
                       "bombs %s U-boat",
/*65*/     0,     3,   "wins big in POGOLOTTO",
                       "makes a bundle playing POGOLOTTO",
/*66*/    -2,     1,   "missiles zero in on %s vessel",
		       "missiles strike %s ship",
/*67*/    -1,     2,   "troops capture %s spy",
                       "snares %s secret agent",
/*68*/    -1,     1,   "breaks up %s spy ring",
                       "scores in cold war",
/*69*/    -5,     1,   "kamikazes terrorize %s targets",
                       "suicide pilots wreak mayhem against %s",
/*70*/	  -1,	  1,   "fighters attack %s ship",
                       "planes strafe %s vessel",
/*71*/	  -1,     1,   "fighters catch %s planes on the ground",
                       "strafe attack pounds %s aircraft",
/*72*/    -1,	  1,   "airforce strafes %s tanks",
                       "pilots shoot up %s tanks",
/*73*/	  -2,     1,   "pilots show no mercy with %s airship",
                       "fighters terrorize %s balloon",
/*74*/	  -3,     1,   "strafe attack blasts %s railway",
                       "pilots terrorize %s train",
/*75*/	  -4,     1,   "pilots strafe %s populace",
                       "strafing raid targets %s women and children",
/*76*/    -1,     1,   "air defense toasts %s missile\n",
	               "shoots down incoming %s missile\n",
};
