#ifndef lint
static char *RCSid = "$Header: cmds.c,v 1.1 89/12/14 12:32:14 jay Exp $";
#endif

/*
 * cmds.c
 *
 * identify remote host, candidate, et al..
 *
 * Dave Pare, 1986
 */

#include <stdio.h>

#include "misc.h"
#include "proto.h"
#include "sailio.h"
#include "login.h"

#include <signal.h>
#include <fcntl.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/errno.h>

#ifndef X_OK
#include <sys/file.h>
#endif

int
user(cp, name)
	struct	candidate *cp;
	char	*name;
{
	char	buf[80];

	if (*name == 0) {
		sendclient(cp->iop, C_CMDERR, "arg error");
		return 0;
	}
	sprintf(buf, "hello %s", name);
	sendclient(cp->iop, C_CMDOK, buf);
	(void) strcpy(cp->remuser, name);
	return 0;
}

/*ARGSUSED*/
int
quit(cp, arg)
	struct	candidate *cp;
	char	*arg;
{
	sendclient(cp->iop, C_EXIT, "so long");
	sflush(cp->iop);
	cd_delete(cp);
	return 1;
}

int coun(cp, name)
    struct	candidate *cp;
    char	*name;
{
    char buf[255];
    FILE *pin;
    int i, cnum, id;
    struct login *lp;
    
    /* 
    **  Let the player try to kill hung processes 
    **  by trying to log on as 'empire kill<pid>'
    */

    if (!strncmp(name,"kill",4) && isdigit(name[4])) {
	id = atoi(name+4);
	if (lp=lo_find(id)) {
	    logerror("%s@%s killing pid %d",
		     cp->remuser, cp->remhost, id);
	    if (kill(id, SIGQUIT)!=0) {
		logerror("kill(%d,%d) failed, using system kill",
			 id,SIGQUIT);
		sprintf(buf,"kill 3 %d",id);
		system(buf);
	    }
	    sprintf(buf,"kill pid %d (was in use by %s@%s)",
		    id, lp->remuser, lp->remhost);
	} else {
	    sprintf(buf,"can't find pid %d in login list",id);
	}
	sendclient(cp->iop, C_EXIT, buf);
	return 0;
    }
    
    if (*name == 0) {
	sendclient(cp->iop, C_CMDERR, "arg error");
	return 0;
    }
    if ((cnum = natbyname(name)) < 0) {
	sprintf(buf, "No such country %s", name);
	sendclient(cp->iop, C_CMDERR, buf);
	return 0;
    }
    cp->cnum = cnum;
    *cp->password = 0;
    sprintf(buf, "country %s ok", name);
    sendclient(cp->iop, C_CMDOK, buf);
    (void) strcpy(cp->countryname, name);
    return 0;
}

int
pass(cp, passwd)
	struct	candidate *cp;
	char	*passwd;
{
	if (*passwd == 0) {
		sendclient(cp->iop, C_CMDERR, "arg error");
		return 0;
	}
	if (*cp->countryname == 0) {
		sendclient(cp->iop, C_CMDERR, "need a country name first!");
		return 0;
	}
	strncpy(cp->password, passwd, sizeof(cp->password)-1);
	if (natpass(cp->cnum, cp->password)) {
		sendclient(cp->iop, C_CMDOK, "password ok");
		logerror("%s@%s using country %s", cp->remuser,
			cp->remhost, cp->countryname);
	} else {
		sendclient(cp->iop, C_CMDERR, "password bad, logging entry");
		logerror("%s@%s tried country %s with %s",
			cp->remuser, cp->remhost, cp->countryname,
			cp->password);
		cp->password[0] = 0;
	}
	return 0;
}

/*ARGSUSED*/
int
play(cp, arg)
	struct	candidate *cp;
	char	*arg;
{
	extern	char playerbin[];
	extern	int errno;
	int	pid;
	int	i;
	int	val = 1;
	char	country[40];
	char	buf[120];
	struct	login *lp;

	if (*cp->password == 0) {
		sendclient(cp->iop, C_CMDERR, "no password entered");
		return 0;
	}
	if (cp->cnum < 0) {
		sendclient(cp->iop, C_CMDERR, "no country entered");
		return 0;
	}
	if ((lp = lo_cnum((natid)cp->cnum)) != 0) {
		if (kill(lp->pid,0) < 0 && errno == ENOENT) {
			logerror("country %d 'in use' but pid %d not found",
				cp->cnum, lp->pid);
			lo_delete(lp);
		} else {
			sprintf(buf, "country in use by %s@%s (pid=%d)",
				lp->remuser, lp->remhost, lp->pid);
			sendclient(cp->iop, C_EXIT, buf);
			return 0;
		}
	}
	sflush(cp->iop);
	if (access(playerbin, X_OK) == -1) {
		sprintf(buf, "cannot execute %s!", playerbin);
		sendclient(cp->iop, C_EXIT, buf);
		return 0;
	}
	pid = fork();
	if (pid == -1) {
		logerror("fork error");
		sendclient(cp->iop, C_DATA, "fork error on server end");
		return 0;
	}
	if (pid != 0) {
		lp = lo_new();
		lp->cnum = cp->cnum;
		lp->pid = pid;
		strcpy(lp->remuser, cp->remuser);
		strcpy(lp->remhost, cp->remhost);
		cd_delete(cp);
		return 1;
	}
	if (setsockopt(cp->iop->fd, SOL_SOCKET, SO_KEEPALIVE,
	    &val, sizeof(val)) < 0)
		logerror("play setsockopt error");
	dup2(sio_fileno(cp->iop), 0);
	dup2(sio_fileno(cp->iop), 1);
	dup2(sio_fileno(cp->iop), 2);
#ifdef notdef
	setfdtablesize(20);
#endif
	for (i=getfdtablesize()-1; i >= 3; i--)
		close(i);
	sprintf(country, "%d", cp->cnum);
	execl(playerbin, "emp_player", country, 0);
	sprintf(buf, "%x cannot exec %s, error %d\n", C_EXIT, playerbin, errno);
	write(1, buf, strlen(buf));
	exit(1);
	/*NOTREACHED*/
}

/*ARGSUSED*/
int
list(us, arg)
	struct	candidate *us;
	char	*arg;
{
	register struct login *lp;
	char	buf[80];

	if (us->cnum != 0 || us->password[0] == 0) {
		sendclient(us->iop, C_CMDERR, "Permission denied");
		return 0;
	}
	sendclient(us->iop, C_DATA, "user@host\tcountry\tpid");
	lp = 0;
	while (lp = lo_next(lp)) {
		sprintf(buf, "%s@%s\t%d\t%d", lp->remuser, lp->remhost,
			lp->cnum, lp->pid);
		sendclient(us->iop, C_DATA, buf);
	}
	sendclient(us->iop, C_DATA, 0);
	return 0;
}

int	iswatching;

/*ARGSUSED*/
int
wat(cp, arg)
	register struct candidate *cp;
	char	*arg;
{
	if (cp->state == STAT_WATCH) {
		cp->state = STAT_NORM;
		iswatching--;
		return 0;
	}
	iswatching++;
	list(cp, 0);
	cp->state = STAT_WATCH;
	return 0;
}
