static char *RCSid = "$Header: service.c,v 1.1 89/12/14 12:32:20 jay Exp $";

/*
 * service.c
 *
 * service a candidate socket by reading all the
 * commands and executing the right routines.
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "proto.h"
#include "sailio.h"
#include "login.h"

#include <netinet/in.h>
#include <errno.h>

struct	fn {
	int	(*func)();
	char	*name;
	int	value;
};

extern	int quit();
extern	int coun();
extern	int pass();
extern	int user();
extern	int play();
extern	int list();
extern	int wat();

struct fn fnlist[] = {
	{ user,	"user",		USER,},
	{ coun,	"coun",		COUN,},
	{ quit,	"quit",		QUIT,},
	{ pass,	"pass",		PASS,},
	{ play,	"play",		PLAY,},
	{ list,	"list",		LIST,},
	{ wat,	"wat",		WAT,},
	{ 0,	"",		0,},
};

int
service(cp)
	struct	candidate *cp;
{
	extern	int errno;
	char	buf[255];
	char	cmd[32];

#ifdef DEBUG
	logerror("servicing %d\n", sio_fileno(cp->iop));
#endif
	do {
		if (cp->iop == 0) {
			logerror("service: iop is nil, cp: %lx\n", cp);
			break;
		}
		if (recvclient(cp->iop, cmd, buf) == 0)
			break;
		/* another magic number; I should care, but I don't */
		buf[32] = '\0';
		if (callfn(cp, cmd, buf) > 0) {
			return 1;
		}
		sflush(cp->iop);
		/*
		 * sio_input...in case more input exists
		 * on that line (i.e. multiple commands
		 * sent in one write() call from that client.
		 */
	} while (sio_input(cp->iop) > 0);
	if (sio_conn(cp->iop)) {
		cd_delete(cp);
		return 1;
	}
	return 0;
}

int
callfn(cp, name, buf)
	struct	candidate *cp;
	char	*name;
	char	*buf;
{
	extern	int iswatching;
	struct	fn *fp;
	int	n;

	for (fp = fnlist; fp->func != 0; fp++) {
		if (strcmp(fp->name, name) == 0)
			break;
	}
	if (fp->func == 0) {
		sendclient(cp->iop, C_BADCMD, "command not found");
		return 0;
	}
	cp->cmd = fp->name;
	n = fp->func(cp, buf);
	if (iswatching)
		dowatch();
	return n;
}

dowatch()
{
	register struct candidate *cp;

	cp = 0;
	while (cp = cd_next(cp)) {
		if (cp->state == STAT_WATCH) {
			list(cp, 0);
			sflush(cp->iop);
		}
	}
}
