#ifndef lint
static char *RCSid = "$Header: convoy.c,v 1.1 91/09/30 08:19:51 bill Exp $";
#endif /* not lint */

/*
**  convoy - add ships to convoy
**  fleet  - add ships to fleet
**  wing   - add planes to wing
**
**  9/30/91 merged flee.c and wing.c (Bill Frolik)
*/

#include <ctype.h>
#include "misc.h"
#include "var.h"
#include "ship.h"
#include "plane.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"
#include "nat.h"

extern char *argp[];

char getgroupid(cp,prompt)
char *cp,*prompt;
{
    char c;
    if (!(cp = getstarg(cp, fmt("%s? ",prompt)))) return 0;
    c = *cp;
    if (!isalpha(c) && c!='~') {
	pr(fmt("Specify %s (1 alpha char or '~')\n",prompt));
	return 0;
    }
    return ((c=='~') ? ' ' : c);
}


flee()   { return groupadd(0); }
convoy() { return groupadd(1); }


groupadd(conv)
int conv;
{
    struct shpstr ship;
    struct nstr_item nstr;
    int vc,count; 
    char c,*gt;

    gt = conv ? "convoy" : "fleet";

    if ((c=getgroupid(argp[1],gt)) == 0) return RET_SYN;
    if (!snxtitem(&nstr, EF_SHIP, argp[2])) return RET_SYN;

    count = 0;
    while (nxtitem(&nstr, (char *)&ship)) {
	if (ship.shp_own != cnum) continue;
	if (!count) vc = mchr[ship.shp_type].m_class;
	else if (vc != mchr[ship.shp_type].m_class) continue;
	if (conv) ship.shp_convoy = c;
	else ship.shp_fleet = c;
	putship(nstr.cur, &ship);
	count++;
    }

    if (!count) pr(fmt("nothing added to %s `%c'\n", gt, c));
    else pr(fmt("%d %s%s added to %s `%c'\n", 
		count, class[vc].name, splur(count), gt, c));
    
    return RET_OK;
}


wing()
{
    
    struct plnstr plane;
    struct nstr_item nstr;
    int count;
    char c;
    
    if ((c=getgroupid(argp[1],"wing")) == 0) return RET_SYN;
    if (!snxtitem(&nstr, EF_PLANE, argp[2])) return RET_SYN;
    count = 0;
    while (nxtitem(&nstr, (char *)&plane)) {
	if (plane.pln_own != cnum) continue;
	plane.pln_wing = c;
	putplane(nstr.cur, &plane);
	count++;
    }
    pr(fmt("%d plane%s added to wing `%c'\n", count, splur(count), c));
    return RET_OK;
}


