#ifndef lint
static char *RCSid = "$Header: diss.c,v 1.1 89/12/14 08:19:40 jay Exp $";
#endif /* not lint */

/*
 * diss.c
 *
 * perhaps the least-used command in empire!
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"
#include "nat.h"
#include "loan.h"
#include "treaty.h"
#include "news.h"
#include "file.h"
#include "xy.h"
#include "nsc.h"
#include "tel.h"
#include <fcntl.h>

diss()
{
	extern	char *argp[];
	struct	sctstr sect;
	struct	shpstr ship;
	struct	plnstr plane;
	struct	trtstr treaty;
	struct	lonstr loan;
	struct	nstr_item ni;
	struct	nstr_sect ns;
	int	sctnum;
	int	damage;
	int	annoyed;
	int	n,natsinuse;
	char	*p;
	struct	natstr nat;
	natid	cn,inuse[MAXNOC];

	p = getstarg(argp[1], "Are you SURE you want to do this? (n) ");
	if (p == 0 || *p != 'y')
		return RET_SYN;
	NAT_SET(nat_stat, cnum, VIS);

	ef_reopen(EF_NATION,O_RDONLY,EFF_MEM);
	for (natsinuse=0; nxtitem(&ni, (char *)&nat);)
	    if ((nat.nat_stat & (STAT_NORM|STAT_SANCT|STAT_GOD)) == STAT_NORM)
		inuse[natsinuse++] = ni.cur;

	snxtsct_all(&ns);
	sctnum = 0;
	while (nxtsct(&ns, &sect)) {
		if (!owner)
			continue;
		annoyed = 75 - (random() % (sect.sct_loyal+40));
		if (annoyed <= 0 || sect.sct_oldown != sect.sct_own) {
			pr(fmt("Populace celebrates in %s\n",
				xyas(sect.sct_x, sect.sct_y, cnum)));
			if (sect.sct_oldown != sect.sct_own) {
				sect.sct_own = sect.sct_oldown;
				wu(0, sect.sct_own,
					fmt("%s reverts back to you!\n",
					xyas(sect.sct_x, sect.sct_y,
					sect.sct_own)));
			}
		} else if (annoyed < 25) {
			pr(fmt("Populace unmoved in %s\n",
				xyas(sect.sct_x, sect.sct_y, cnum)));
			sect.sct_own = 0;
			sect.sct_oldown = 0;
		} else {
			pr(fmt("Rioting breaks out in %s\n",
				xyas(sect.sct_x, sect.sct_y, cnum)));
			sectdamage(&sect, annoyed);
			sctnum++;
			sect.sct_own = 0;
			sect.sct_oldown = 0;
		}
		putsect(&sect);
	}
	snxtitem_all(&ni, EF_SHIP);
	while (nxtitem(&ni, (char *)&ship)) {
		if (!owner)
			continue;
		pr(fmt("%s #%d ", mchr[ship.shp_type].m_name, 
			ship.shp_uid));
		switch (random() % 3) {
		case 0:
			pr("scuttled!\n");
			ship.shp_effic = 0;
			break;
		case 1:
			pr("abandoned!\n");
			putvar(V_MILIT, 0, (char *)&ship, EF_SHIP);
			putvar(V_CIVIL, 0, (char *)&ship, EF_SHIP);
			putvar(V_UW, 0, (char *)&ship, EF_SHIP);
			break;
		case 2:
			if (chance(0.5)) {
			    if (getsect(ship.shp_x,ship.shp_y,&sect)) {
				if (sect.sct_own && sect.sct_own!=cnum)
				    n = sect.sct_own;
				else 
				    n = inuse[random() % natsinuse];
				pr(fmt("defected to %s!\n",cname(n)));
				wu(0, n,
				   fmt("%s %s #%d has defected to you @ %s",
				       cname(ship.shp_own),
				       mchr[ship.shp_type].m_name,
				       ship.shp_uid,
				       xyas(ship.shp_x,ship.shp_y,n)));
				ship.shp_own = n;
				break;
			    }
			}
		default:
			damage = (random() % 80) + 10;
			pr(fmt("crew has rioted! (%d%% damage)\n", damage));
			shipdamage(&ship, damage);
			sctnum++;
			break;
		}
		putship(ship.shp_uid, &ship);
	}
	snxtitem_all(&ni, EF_PLANE);
	while (nxtitem(&ni, (char *)&plane)) {
		if (!owner)
			continue;
		pr(fmt("%s #%d ", plchr[plane.pln_type].pl_name,
			plane.pln_uid));
		switch (random() % 2) {
		case 0:
			pr("blown up!\n");
			plane.pln_effic = 0;
			break;
		case 1:
		default:
			damage = (random() % 80) + 10;
			pr(fmt("crew has rioted! (%d%% damage)\n", damage));
			planedamage(&plane, damage);
			sctnum++;
			break;
		}
		putplane(plane.pln_uid, &plane);
	}
	snxtitem_all(&ni, EF_TREATY);
	while (nxtitem(&ni, (char *)&treaty)) {
		if (treaty.trt_status == TS_FREE)
			continue;
		if (treaty.trt_cna != cnum && treaty.trt_cnb != cnum)
			continue;
		cn = treaty.trt_cna == cnum ? treaty.trt_cnb : treaty.trt_cna;
		pr(fmt("No more treaty with %s\n", cname(cn)));
		wu(0, cn, fmt("Treaty #%d with %s voided",
			ni.cur, cname(cnum)));
		treaty.trt_status = TS_FREE;
		puttre(ni.cur, &treaty);
	}
	snxtitem_all(&ni, EF_LOAN);
	while (nxtitem(&ni, (char *)&loan)) {
		if (loan.l_status == LS_FREE)
			continue;
		if (loan.l_loner != cnum && loan.l_lonee != cnum)
			continue;
		if (loan.l_loner == cnum) {
			pr(fmt("Loan #%d to %s will never be repaid\n",
				ni.cur, cname(loan.l_lonee)));
			wu(0, loan.l_lonee,
				fmt("Loan #%d from %s has been voided\n",
					ni.cur, cname(cnum)));
		} else {
			pr(fmt("Loan #%d from %s will never be repaid\n",
				ni.cur, cname(loan.l_lonee)));
			wu(0, loan.l_loner,
				fmt("Loan #%d to %s has been voided\n",
				ni.cur, cname(cnum)));
		}
		loan.l_status = LS_FREE;
		putloan(ni.cur, &loan);
	}
	while (sctnum > 0) {
		n = sctnum > 127 ? 127 : sctnum;
		nreport(cnum, N_RIOT, 0, n);
		sctnum -= n;
	}
	filetruncate(mailbox(cnum));
	NAT_SET(nat_stat, cnum, STAT_INUSE);
	NAT_SET(nat_btu, cnum, 0);
	nstat = VIS;
	wu(0, 0, fmt("Country #%d (%s) has dissolved\n",
		cnum, cname(cnum)));
	nreport(cnum, N_DISS_GOV, 0, 1);
	return RET_OK;
}
