#ifndef lint
static char *RCSid = "$Header: load.c,v 1.1 89/12/14 08:20:06 jay Exp $";
#endif /* not lint */

/*
 * load.c
 *
 * load (unload) goods from a sector onto a ship
 *
 * from PSL Empire, 1985
 *
 * hacked to allow planes/missiles to be loaded onto carriers/subs
 * by David Sharnoff 1987 
 * XXX needs to be told "plane" or commodity before amount.
 *
 * 12/7/90 bf@hp - hacked for use as a temporary buy() and sell()
 */

#include "misc.h"
#include "xy.h"
#include "file.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "plane.h"	
#include "item.h"
#include "nsc.h"
#include "nat.h"
#include "deity.h"

#ifdef TRADECENTERS
#include "news.h"
#include "shop.h"
#endif

/*
 * The values 1 and -1 are important below, don't change them.
 */
#define	LOAD	1
#define	UNLOAD	-1

int
load()
{
    extern	char *argp[];
    register struct ichrstr *ich;
    register int item;
    register int max_amt;
    register int move_amt;
    register int ship_amt;
    register int sect_amt;
    struct shpstr ship,vehicle;
    struct sctstr sect;
    struct plnstr pln;	/* for nuke subs */
    struct natstr *natp;
    struct mchrstr *mp;
    int load_unload;
    int ship_num;
    int amount,loadable,relat;
    int is_plane,is_tank;
    int nplanes,ntanks;
    int mil,civ;
    int	vc;
    struct nstr_item nbst;
    char *p,*i;
    int	nships;
    char linebuf[80];
#ifdef TRADECENTERS
    tradecenter shop;
    int dobusiness;
    float totalcost;
#endif
    
    natp = getnatp(cnum);
    p = getstarg(argp[1],fmt("%s(s): ",STB(1)));
    if (!p || !*p) return RET_SYN;
    if (!snxtitem(&nbst, EF_SHIP, p)) return RET_SYN;

    /* discriminate 'load' and 'buy' from 'unload' and 'sell' */
    load_unload = ((**argp=='l')||(**argp=='b')) ? LOAD : UNLOAD;

    strcpy(linebuf,"Commodity amount");
    if (**argp!='b' && **argp!='s') {
#ifdef PLANES
	strcat(linebuf," or plane");
#endif
#ifdef TANKS
	strcat(linebuf," or tank");
#endif
    }
    strcat(linebuf," #: ");
    
    p = getstarg(argp[2],linebuf);
    if (p == 0 || *p == 0)
	return RET_SYN;
    amount = atoi(p);

    if (amount < 0) {	/* plane 0 is a valid plane number */
	pr("Amount must be non-negative.\n");
	return RET_SYN;
    }

    strcpy(linebuf,"What commodity");
    if (**argp!='b' && **argp!='s') {
#ifdef PLANES
	strcat(linebuf,", or 'plane'");
#endif
#ifdef TANKS
	strcat(linebuf,", or 'tank'");
#endif
    }
    strcat(linebuf," : ");

    i = getstarg(argp[3],linebuf);
    if (i == 0 || i[0] == '\0')	return RET_SYN;

    if (**argp=='b' || **argp=='s') is_plane = is_tank = 0;
    else {
	is_plane = !strncmp(i,"plane",5);	/* XXX */
	is_tank = !strncmp(i,"tank",4);		/* bf@hp */
    }

#ifdef TANKS
    /* ________________________________________________________________
    **|                                                                |
    **| load/unload a vehicle -- sanity check                          |
    **|________________________________________________________________|
    */

    if (is_tank) {

	if (!getship(amount,&vehicle)) return RET_SYN;

	/* make sure it's really a tank */
	if (!istank(&vehicle)) {
	    pr(fmt("Not a %s!\n",class[CLASS_TANK].name));
	    return RET_FAIL;
	}
	
	/* can't load nonallied vehicles, but can unload anyone's vehicle */
	loadable = ((load_unload==UNLOAD) || god || (vehicle.shp_own==cnum));
	if (!loadable) loadable = (getrel(natp,vehicle.shp_own)==ALLIED);
	if (!loadable) {
	    pr("Can only load your own or allied vehicles!\n");
	    return RET_FAIL;
	}

	if (load_unload==LOAD && vehicle.shp_aboard>=0) {
	    getship(vehicle.shp_aboard,&ship);
	    pr(fmt("%s #%d is already aboard %s #%d!\n",
		   mchr[vehicle.shp_type].m_name,vehicle.shp_uid,
		   mchr[ship.shp_type].m_name,vehicle.shp_aboard));
	    return RET_FAIL;
	}

	dpr(fmt("%s #%d: vehicle qualifies",mchr[vehicle.shp_type].m_name,
		vehicle.shp_uid));
    }
#endif

#ifdef PLANES
    /* ________________________________________________________________
    **|                                                                |
    **| load/unload a plane -- sanity check                            |
    **|________________________________________________________________|
    */

    if (is_plane) {

	if (!getplane(amount, &pln))
	    return RET_SYN;

/* this is checked again later on:
**
**	if (!(plchr[pln.pln_type].pl_flags & P_L)) {
**	    pr("You can only load light missiles or light aircraft.\n");
**	    return RET_FAIL;
**	}
*/
	/* can't load hostile planes, but can unload anyone's plane */
	loadable = ((load_unload==UNLOAD) || god || (pln.pln_own==cnum));
	if (!loadable) loadable = (getrel(natp,pln.pln_own)<=ALLIED);
	if (!loadable) {
	    pr("Can't load that plane!\n");
	    return RET_FAIL;
	}

	if (load_unload==LOAD && pln.pln_ship>=0) {
	    getship(pln.pln_ship,&ship);
	    pr(fmt("%s #%d is already aboard %s #%d!\n",
		   plchr[pln.pln_type].pl_name,pln.pln_uid,
		   mchr[ship.shp_type].m_name,pln.pln_ship));
	    return RET_FAIL;
	}
    }
#endif

    /* ________________________________________________________________
    **|                                                                |
    **| load/unload a commodity -- sanity check                        |
    **|________________________________________________________________|
    */

    if (!is_tank && !is_plane) {

	/* Changed to fix the bug in load,  Frederic Chauveau <fmc@cnam.cnam.fr>           ich = whatitem(i, (char *)0); */
        ich = whatitem(i, "What commodity");
	if (ich == 0) {
	    pr("Bad commodity.\n");
	    return RET_SYN;
	}
	if (amount == 0) {
	    pr("Amount must be positive.\n");
	    return RET_SYN;
	}

    }

    /* ________________________________________________________________
    **|                                                                |
    **| MAIN LOOP                                                      |
    **|________________________________________________________________|
    */

    nships = 0;
    while (nxtitem(&nbst, (char *)&ship)) {
	if (!owner) continue;

	natp = getnatp(cnum);
	ship_num = ship.shp_uid;
	mp = &mchr[ship.shp_type];
	vc = vehicleclass(&ship);

	pr(fmt("\t%s at %s\n", shipas(&ship,0),
	       xyas(ship.shp_x, ship.shp_y, cnum)));
	if (!getsect(ship.shp_x, ship.shp_y, &sect)) {
	    pr(fmt("Can't get sector %s\n",xyas(ship.shp_x,ship.shp_y,cnum)));
	    continue;
	}

	/* 
	**  Check against loading/unloading while being transported.
	*/
	
	if (ship.shp_aboard >= 0) {
	    pr(fmt("Use 'tend' to %sload %ss during transport.\n",
		   (load_unload==UNLOAD) ? "un" : "",class[vc].name));
	    continue;
	}

	/*
	**  Check altitude and depth.
	*/

	if (ship.shp_depth != 0) {
	    pr(fmt("%s can't %sload while %s.\n",
		   shipas(&ship,0),
		   load_unload==UNLOAD ? "un" : "",
		   isship(&ship) ? "submerged" : "airborne"));
	    continue;
	}

	/* 
	**  Check against loading/unloading in improper sectors.
	*/
	
	if (!(isballoon(&ship) && load_unload==UNLOAD)) {
	    if (!stypeinlist(class[vc].loadplace,sect.sct_type)) {
		pr(fmt("%s is a %s.\n(A %s can %sload only in %s.)\n",
		       xyas(ship.shp_x, ship.shp_y, cnum),
		       dchr[sect.sct_type].d_name,
		       class[vc].name,
		       load_unload==UNLOAD ? "un" : "",
		       fmslist(class[vc].loadplace)));
		continue;
	    }
	}

	if (sect.sct_type<SCT_RURAL) {
	    pr(fmt("You can't %sload there.\n",load_unload==UNLOAD?"un":""));
	    continue;
	}

	/*
	**  Check against loading/unloading in foreign sectors.
	*/

	mil = getvar(V_MILIT,(char *)&sect,EF_SECTOR);
	civ = getvar(V_CIVIL,(char *)&sect,EF_SECTOR);

#ifdef TRADECENTERS
	dobusiness = 0;
	if (sect.sct_own!=ship.shp_own && !is_tank && !is_plane) {
	    if (sect.sct_type!=SCT_TRADE && load_unload==LOAD) {
		if ((mil+civ) == 0) pr("Pillaging?\n");
		else {
		    pr(fmt("Sector %s is not yours; you can't load there.\n",
			   xyas(ship.shp_x, ship.shp_y, cnum)));
		    continue;
		}
	    }
	    if (sect.sct_type==SCT_TRADE) {
		lockshop();
		dobusiness = getshop(ship.shp_x,ship.shp_y,&shop);
		unlockshop();
		if (dobusiness) if (!shopstatus(&shop,cnum,2)) {
		    pr(fmt("Sector %s refuses to do business with you.\n",
			   xyas(ship.shp_x,ship.shp_y,cnum)));
		    continue;
		}
	    }
	}
#else
	/*
	**  You can unload in anyone's sectors, but you can load
	**  only in sectors that you own or that contain no people.
	*/

	if (load_unload==LOAD && !is_ship && !is_plane
	    && sect.sct_own!=ship.shp_own && ((mil+civ) != 0)) {
	    pr(fmt("Sector %s is not yours; you can't load there.\n",
		   xyas(ship.shp_x, ship.shp_y, cnum)));
	    continue;
	}
#endif
	
	/*
	**  Check against loading/unloading in an inefficient sector.
	**  Land vehicles are exempt.
	*/

	if (vc!=CLASS_TANK && vc!=CLASS_TRAIN && sect.sct_effic<2) {
	    pr(fmt("The %s at %s is not 2%% efficient yet.\n",
		   dchr[sect.sct_type].d_name,
		   xyas(ship.shp_x, ship.shp_y, cnum)));
	    continue;
	}

#ifdef TANKS
	/* ________________________________________________________________
	**|                                                                |
	**| load/unload a vehicle                                          |
	**|________________________________________________________________|
	*/

	if (is_tank) {

	    if (load_unload == UNLOAD) {
		if (vehicle.shp_aboard != ship.shp_uid) {
		    continue;
		}
	    } else {
		if (ship.shp_x!=vehicle.shp_x ||
		    ship.shp_y!=vehicle.shp_y) {
		    continue;
		}
	    }
	    
	    if (!mp->m_maxtnks) {
		pr(fmt("%s #%d cannot transport vehicles.\n",
		       mp->m_name,ship.shp_uid));
		return RET_FAIL;
	    }

	    ntanks = ship.shp_ntank + load_unload;

	    if (ntanks > mp->m_maxtnks) {
		pr(fmt("%s #%d already has %d vehicles aboard!\n",
		       mp->m_name,ship.shp_uid,mp->m_maxtnks));
		return RET_FAIL;
	    }

	    if (ntanks < 0) ntanks = 0; /* quietly fix this if it happens */

	    ship.shp_ntank = ntanks;
	    vehicle.shp_aboard = (load_unload==LOAD) ? ship.shp_uid : -1;

	    dpr(fmt("putship(%d) saving vehicle",vehicle.shp_uid));
	    if (!putship(vehicle.shp_uid, &vehicle)) {
		pr("Couldn't save vehicle; get help!\n");
		return RET_SYS;
	    }

	    dpr(fmt("putship(%d) saving transport",ship.shp_uid));
	    if (!putship(ship.shp_uid, &ship)) {
		pr("Couldn't save ship; get help!\n");
		return RET_SYS;
	    }

	    pr(fmt("%s #%d %s %s #%d @ %s.\n",
		   mchr[vehicle.shp_type].m_name,
		   vehicle.shp_uid,
		   (load_unload==UNLOAD) ? "unloaded from" : "loaded onto",
		   mp->m_name,ship.shp_uid,
		   xyas(ship.shp_x, ship.shp_y, cnum)));

	    return RET_OK;
	}
#endif
	
#ifdef PLANES
	/* ________________________________________________________________
	**|                                                                |
	**| load/unload a plane                                            |
	**|________________________________________________________________|
	*/

	if (is_plane) {
	    
	    /*
	    ** Note that there is only one plane per transaction
	    ** Plane sanity done; find the right ship.
	    */

	    if (load_unload == UNLOAD) {
		if (pln.pln_ship != ship.shp_uid)
		    continue;
	    } else {
		if (ship.shp_x != pln.pln_x ||
		    ship.shp_y != pln.pln_y)
		    continue;
	    }

	    /* ship to (plane or missle) sanity */
	    if (pln.pln_flags & PLN_BOXED) {
		if (!(mp->m_flags & M_TAC)) {
		    pr(fmt("%s #%d cannot transport disassembled aircraft.\n",
			   mp->m_name,ship.shp_uid,i));
		    return RET_FAIL;
		}
	    } else {
		if (!planefitsship(plchr[pln.pln_type].pl_flags,mp->m_flags)) {
		    if (plchr[pln.pln_type].pl_flags & P_M) i="missiles";
		    else if (plchr[pln.pln_type].pl_flags & P_H) i="helicopters";
		    else i="aircraft";
		    pr(fmt("%s #%d cannot carry such %s.\n",
			   mp->m_name,ship.shp_uid,i));
		    return RET_FAIL;
		}
	    }

	    /* Fit plane on ship */
	    nplanes = ship.shp_nplane + load_unload;

	    if (nplanes > mp->m_maxplns) {
		pr(fmt("%s #%d can only carry %d aircraft or missiles.\n",
		       mp->m_name,ship.shp_uid,
		       mp->m_maxplns));
		return RET_FAIL;
	    }

	    if (nplanes < 0) nplanes = 0; /* quietly fix this if it happens */
	    
	    ship.shp_nplane = nplanes;
	    pln.pln_ship = (load_unload==UNLOAD) ? -1 : ship.shp_uid;

	    if (!putplane(pln.pln_uid, &pln)) {
		pr("Couldn't save plane; get help!\n");
		return RET_SYS;
	    }

	    if (!putship(ship.shp_uid, &ship)) {
		pr("Couldn't save ship; get help!\n");
		return RET_SYS;
	    }

	    pr(fmt("%s #%d %s%s %s #%d.\n",
		   plchr[pln.pln_type].pl_flags & P_M ? "Missle" : "Aircraft",
		   pln.pln_uid,
		   (pln.pln_flags & PLN_BOXED) ? "crates " : "",
		   (load_unload==UNLOAD)? "unloaded from":"loaded onto",
		   mp->m_name,
		   ship.shp_uid, 
		   xyas(ship.shp_x, ship.shp_y, cnum)));

	    return RET_OK;
	}
#endif

	/* ________________________________________________________________
	**|                                                                |
	**|load/unload a commodity                                         |
	**|________________________________________________________________|
	*/

	item = ich->i_vtype;
	ship_amt = getvar(item, (char *)&ship, EF_SHIP);
	sect_amt = getvar(item, (char *)&sect, EF_SECTOR);
	if (sect.sct_oldown != cnum && item == V_CIVIL) {
	    pr(fmt("%s civilians refuse to %s at %s!\n",
		   load_unload == UNLOAD ? "Your" : "Foreign",
		   load_unload == UNLOAD ?
		   "disembark" : "board",
		   xyas(sect.sct_x, sect.sct_y, cnum)));
	    continue;
	}
	if (load_unload == UNLOAD) {
	    max_amt = min(999 - sect_amt, ship_amt);
	} else {
	    struct mchrstr *vbase;
	    vbase = &mchr[ship.shp_type];
	    max_amt = vl_find(item, vbase->m_vtype,
			      vbase->m_vamt, (int) vbase->m_nv);
	    max_amt = min(sect_amt, max_amt - ship_amt);
	}
	if (max_amt <= 0) continue;
	move_amt = load_unload * min(amount, max_amt);
	if (move_amt == 0) continue;

#ifdef TRADECENTERS
	if (dobusiness) {
	    struct natstr *npsect,*npship;
	    long tcost;
	    int it = unitem(item);
	    if (move_amt < 0) {

		/*
		**  Ship sells item to sector
		*/

		if ( (sect_amt >= shop.item[it].hiwater) ||
		    ( shop.item[it].buyprice < 0.0) ) {
		    pr(fmt("%s isn't buying %s.\n",
			   xyas(sect.sct_x,sect.sct_y,cnum),ich->i_name));
		    continue;
		}

		if ((sect_amt-move_amt) > shop.item[it].hiwater) {
		    move_amt = sect_amt-shop.item[it].hiwater;
		    pr(fmt("%s wants to buy only %d %s.\n",
			   xyas(sect.sct_x,sect.sct_y,cnum),
			   -move_amt,ich->i_name));
		}

		npsect = getnatp(sect.sct_own);
		totalcost = (double)(-move_amt)*shop.item[it].buyprice;
		tcost = (long)(totalcost+0.5);
		totalcost = tcost;

		if (totalcost > 0.5*npsect->nat_money) {
		    wu(0,sect.sct_own,
		       fmt("%s attempted to sell %d %s for $.2f in %s",
			   cname(ship.shp_own),-move_amt,ich->i_name,totalcost,
			   xyas(sect.sct_x,sect.sct_y,sect.sct_own)));
		    pr(fmt("$.2f sale exceeds budget in %s, %s refused.\n",
			   totalcost, xyas(sect.sct_x,sect.sct_y,ship.shp_own),
			   ich->i_name));
		    continue;
		}

		if (move_amt == 0) continue;
		pr(fmt("Sold %d %s in %s for $%.2f.\n",
		       -move_amt,ich->i_name,
		       xyas(sect.sct_x,sect.sct_y,cnum),totalcost));
		wu(0,sect.sct_own,
		   fmt("%s bought %d %s from %s %s #%d for $%.2f.",
		       xyas(sect.sct_x,sect.sct_y,sect.sct_own),
		       -move_amt,ich->i_name,cname(cnum),
		       mp->m_name,ship.shp_uid,totalcost));
		NAT_DELTA(nat_money, sect.sct_own, -tcost);
		NAT_DELTA(nat_money, ship.shp_own, tcost);
	    }

	    else {

		/*
		**  Ship buys item from sector
		*/

		if ( (sect_amt <= shop.item[it].lowater)
		    || (shop.item[it].sellprice < 0.0) ) {
		    pr(fmt("%s isn't selling %s.\n",
			   xyas(sect.sct_x,sect.sct_y,cnum),ich->i_name));
		    continue;
		}

		if ((sect_amt-move_amt) < shop.item[it].lowater) {
		    move_amt = sect_amt-shop.item[it].lowater;
		    pr(fmt("%s is only offering %d %s.\n",
			   xyas(sect.sct_x,sect.sct_y,cnum),
			   move_amt,ich->i_name));
		}

		totalcost = (double)move_amt
		    * shop.item[it].sellprice
		    * shop.pricemult[cnum];
		tcost = (long)(totalcost + 0.5);
		totalcost = tcost;

		npship = getnatp(ship.shp_own);

		/* Inform player of big transactions */
		if (totalcost > 0.25*npship->nat_money || totalcost > 5000.0)
		    pr(fmt("You have $%.2f; %d %s will cost $%.2f.\n",
			   (double)npship->nat_money,
			   move_amt,ich->i_name,totalcost));

		/* Can't fork over the cash */
		if (tcost > npship->nat_money) {
		    pr("That's too spendy for your budget.\n");
		    continue;
		}

		/* Give player a chance to abort extremely big transactions */
		if (totalcost > 0.4*npship->nat_money) {
		    int pcnt = 
			(int)((totalcost*100.0)/(double)npship->nat_money);
		    pr(fmt("That's %2d%% of your available cash!\n",pcnt));
		    p = getstarg(argp[4],"Continue with purchase? ");
		    if (!p || ((*p!='y') && (*p!='Y'))) {
			pr("No sale.  ");
			if (pcnt > 90) pr("(Probably a wise decision.)");
			pr("\n");
			continue;
		    }
		}

		if (move_amt == 0) continue;
		pr(fmt("Bought %d %s in %s for $%.2f.\n",move_amt,ich->i_name,
		       xyas(sect.sct_x,sect.sct_y,cnum),totalcost));
		wu(0,sect.sct_own,
		   fmt("%s %s #%d @ %s bought %d %s from you for $%.2f.",
		       cname(cnum), mp->m_name,
		       ship.shp_uid,xyas(sect.sct_x,sect.sct_y,sect.sct_own),
		       move_amt,ich->i_name,totalcost));
		NAT_DELTA(nat_money,ship.shp_own,-tcost);
		NAT_DELTA(nat_money,sect.sct_own,tcost);
	    }
	}
#endif
        putvar(item, sect_amt - move_amt, (char *)&sect, EF_SECTOR);
	putvar(item, ship_amt + move_amt, (char *)&ship, EF_SHIP);

	/* load/unload plague */
	if (getvar(V_PSTAGE, (char *)&sect, EF_SECTOR) == PLG_INFECT &&
	    getvar(V_PSTAGE, (char *)&ship, EF_SHIP) == PLG_HEALTHY) {
	    putvar(V_PSTAGE, PLG_EXPOSED, (char *)&ship, EF_SHIP);
	}

	if (getvar(V_PSTAGE, (char *)&ship, EF_SHIP) == PLG_INFECT &&
	    getvar(V_PSTAGE, (char *)&sect, EF_SECTOR) == PLG_HEALTHY) {
	    putvar(V_PSTAGE, PLG_EXPOSED, (char *)&sect, EF_SECTOR);
	}
	
	putsect(&sect);
	putship(ship_num, &ship);
	nships++;
    }

    if (!nships) pr("No loads/unloads done\n");
    else pr(fmt("%d %sloads done\n", 
		nships,(load_unload==UNLOAD) ? "un" : ""));
    
    return RET_OK;
}
