#ifndef lint
static char *RCSid = "$Header: mult.c,v 1.1 89/12/14 08:20:13 jay Exp $";
#endif /* not lint */

/*
 * mult.c
 *
 * Set per-nation list of price multipliers.  This should go in the
 * nation structure I think...
 *
 * Dave Pare, 1986
 *
 * 11/28/90 bf@hp - Totally rewritten to move multipliers into the
 *		    nation structure and improve command syntax.
 */

#include "misc.h"
#include "var.h"
#include "nat.h"
#include "file.h"
#include "xy.h"
#include "nsc.h"
#include <fcntl.h>

mult()
{
    extern char *argp[];
    struct natstr *np;
    extern double minmult;
    double price;
    int	i;
    
    ef_reopen(EF_NATION,O_RDONLY,EFF_MEM);

    np = getnatp(cnum);

    /* show all multipliers */
    if ( (!argp[1] || !*argp[1]) ||
	((*argp[1]=='*') && (!argp[2] || !*argp[2])) ) {
	for (i=1;i<MAXNOC;i++)
	    if (cname(i) && *cname(i) && i!=cnum)
		pr(fmt("%3d %-12s %7.3f\n",i,cname(i),np->nat_pricemult[i]));
	return RET_OK;
    }

    if (!argp[2] || !*argp[2]) { /* show one multiplier */
	i = atoi(argp[1]);
	if (i<1 || i>=MAXNOC) return RET_SYN;
	if (!(cname(i) && *cname(i))) {
	    pr("Invalid country\n"); 
	    return RET_SYN;
	}
	pr(fmt("%3d %-12s %7.3f\n",i,cname(i),np->nat_pricemult[i]));
	return RET_OK;
    }
    
    price = (double)atof(argp[2]);
    if (price == 0.0) return RET_SYN;
    if (price < minmult) price = minmult;

    if (*argp[1] != '*') {
	i = atoi(argp[1]);
	NAT_SETARY(nat_pricemult[0],cnum,i,price);
    } else {
	for (i=1;i<MAXNOC;i++) {
	    NAT_SETARY(nat_pricemult[0],cnum,i,price);
	}
    }
    return RET_OK;
}


double multread(seller,buyer)
natid seller,buyer;
{
    struct natstr *np;

    ef_reopen(EF_NATION,O_RDONLY,EFF_MEM);

    if (seller<0 || seller>(MAXNOC-1) || buyer<0 || buyer>(MAXNOC-1))
	return(0.0);
    if (np=getnatp(seller))
	return(np->nat_pricemult[buyer]);
    else
	return(0.0);
}
