#ifndef lint
static char *RCSid = "$Header: buy.c,v 1.1 89/12/14 08:19:19 jay Exp $";
#endif /* not lint */

/*
** open.c
**
** open/close trade centers
*/

#include "misc.h"
#include "xy.h"
#include "file.h"
#include "var.h"
#include "sect.h"
#include "nat.h"
#include "news.h"
#include "nsc.h"
#include "item.h"
#include "deity.h"
#include "shop.h"

/*
** format: open  <SECTOR> <COUNTRY>
**         close <SECTOR> <COUNTRY>
*/

ope() { openshop(1); }
clo() { openshop(0); }

openshop(openup)
int openup;
{
#ifdef TRADECENTERS
    extern char *argp[];
    struct sctstr sect;
    struct nstr_sect nstr;
    tradecenter shop;
    int	i,j,n,nat;
    float mult;
    coord x, y;
    char *p,*s;
    
    openup = openup ? 1 : 0;
    
    if (!snxtsct(&nstr, argp[1])) return RET_SYN;
    
    s = openup ? "Open" : "Close";

    p = argp[2];
    nat = natorsectarg(p,fmt("%s to which country? ",s));
    if ((nat < 0) && (nat != -2))
	return RET_SYN;

    mult = 1.0;
    if (openup && nat!=cnum) {
	p = getstarg(argp[3],"Local price multiplier? ");
	if (p && isdigit(*p)) mult = atof(p);
	if (mult < 0.0) mult = 0.01;
	if (mult > 1000000.0) mult = 1000000.0;
    }

    dpr(fmt("%s %s %d\n",s,argp[1],nat));

    for (n=0; nxtsct(&nstr,&sect); ) {
	if ((!owner && !god) || (sect.sct_type != SCT_TRADE)) continue;
	if (sect.sct_newtype != SCT_TRADE) {
	    if (!n++) {
		if (god) pr(" own");
		pr("   x,y     is open to         multiplier\n\n");
	    }
	    if (god) pr(fmt("%3d ",sect.sct_own));
	    pr(xyfmt("%4d,%-4d  dismantling, cannot be opened or closed\n",
		     sect.sct_x,sect.sct_y,cnum));
	    continue;
	}

	lockshop();
	if (!getshop(sect.sct_x,sect.sct_y,&shop)) continue;
	if (nat < 0) for (i=0;i<MAXNOC;i++) {
	    shopstatus(&shop,i,openup);
	    shop.pricemult[i] = (i==cnum) ? 1.0 : mult;
	}
	else {
	    shopstatus(&shop,nat,openup);
	    shop.pricemult[nat] = (i==cnum) ? 1.0 : mult;
	}
	shopwrite(&shop,-1);
	unlockshop();

	if (!n++) {
	    if (god) pr(" own");
	    pr("   x,y     is open to         multiplier\n\n");
	}
	if (god) pr(fmt("%3d ",sect.sct_own));
	pr(xyfmt("%4d,%-4d  ", shop.x, shop.y, cnum));

	for (i=j=0;i<MAXNOC;i++) {
	    if (i==cnum) continue;
	    if (!(cname(i) && *cname(i))) continue;
	    if (shopstatus(&shop,i,2)) {
		if (god && j) pr("    ");
		pr(fmt("%s(#%3d) %-12.12s %9.2f\n",
		       (j ? "           " : ""),
		       i,cname(i),shop.pricemult[i]));
		j++;
	    }
	}
	if (!j) pr("** closed **\n");
	pr("\n");
    }
    if (!n) pr("No"); else pr(fmt("%d",n)); pr(" trade center(s)\n");
    return RET_OK;
#endif
}
