#ifndef lint
static char *RCSid = "$Header: reco.c,v 1.1 89/12/14 08:20:38 jay Exp $";
#endif

/*
 * reco.c
 *
 * Fly a recon 
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "sect.h"
#include "ship.h"
#include "item.h"
#include "plane.h"
#include "nuke.h"
#include "xy.h"
#include "nsc.h"
#include "news.h"
#include "file.h"
#include "nat.h"
#include "path.h"

swee() { return(recon(1)); }
reco() { return(recon(0)); }

recon(sweeping)
int sweeping;
{
	extern	char *argp[];
	char	*p;
	int	mission_flags;
	coord	tx, ty;
	coord	ax, ay;
	int	ap_to_target;
	char	flightpath[256];
	int	cno;
	struct	nstr_item ni_bomb;
	struct	nstr_item ni_esc;
	coord	x, y;
	struct	sctstr target;
	struct	qelem bomb_list;
	struct	qelem esc_list;
	int	wantflags;
	struct	sctstr ap_sect;

	wantflags = 0;

	if (!snxtitem(&ni_bomb, EF_PLANE, argp[1]))    return RET_SYN;
	if (!snxtitem(&ni_esc, EF_PLANE, argp[2]))     pr("No escorts...\n");
	if (!getassemblypoint(argp[1],argp[3],&x,&y))  return RET_SYN;
	if (!getsect(x, y, &ap_sect))		       return RET_SYN;

#ifndef ASSEMBLEANYWHERE
	if (ap_sect.sct_own && ap_sect.sct_own != cnum) {
	    pr("Assembly point not owned by you!\n");
	    return RET_SYN;
	}
#endif
	p = getpath(argp[4], ax=x, ay=y, 0, 0, 0);
	if (!p || !*p) return RET_SYN;
	(void)strcpy(flightpath, p);
	tx = ax;
	ty = ay;
	(void) pathtoxy(flightpath, &tx, &ty, fcost);
	pr(fmt("target is %s\n", xyas(tx, ty, cnum)));
	getsect(tx, ty, &target);
	cno = -1;
	if (pln_onewaymission(&target, &cno, &wantflags) < 0) return RET_SYN;
	ap_to_target = strlen(flightpath);
	pr(fmt("range to target is %d\n", ap_to_target));
	/*
	**  Select planes within range.
	*/
	if (sweeping) wantflags = P_H;
	pln_sel(&ni_bomb, &bomb_list, &ap_sect, ap_to_target,
		1, wantflags, P_M|P_O, "");
	pln_sel(&ni_esc, &esc_list, &ap_sect, ap_to_target,
		1, P_F|wantflags, P_M|P_O, "");
	/*
	**  Now arm and equip the bombers, transports, whatever.
	**  tech is stored in high 16 bits of mission_flags.
	*/
	mission_flags = 0x7fff0000;
	mission_flags = sweeping
	    ? pln_arm(&bomb_list, 'w', 0, P_MS, mission_flags)
	    : pln_arm(&bomb_list, 'r', 0, P_S|P_I|P_U, mission_flags|P_X);
	if (QEMPTY(&bomb_list)) {
		pr("No planes could be equipped for the mission.\n");
		return RET_FAIL;
	}
	mission_flags = pln_arm(&esc_list, 'r', 0, P_F, mission_flags);
	if (!sweeping) mission_flags |= PM_R;
	ac_encounter(&bomb_list, &esc_list, ax, ay, flightpath, mission_flags);
	if (QEMPTY(&bomb_list)) {
		pr(fmt("No planes got through fighter defenses\n"));
	} else {
		getsect(tx, ty, &target);
		pln_newlanding(&bomb_list, tx, ty, cno);
		pln_newlanding(&esc_list, tx, ty, cno);
	}
	pln_put(&bomb_list);
	pln_put(&esc_list);
	return RET_OK;
}
