#ifndef lint
static char *RCSid = "$Header: reso.c,v 1.1 89/12/14 08:20:43 jay Exp $";
#endif /* not lint */

/*
 * reso.c
 *
 * display natural resources; stolen from cens
 *
 * Dave Pare, 1989
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "ship.h"
#include "sect.h"
#include "nsc.h"
#include "nat.h"
#include "deity.h"
#include "path.h"
#include "file.h"

typedef struct {
    coord x,y;
} seaspot;
    
static	reso_hdr();

reso()
{
    extern char *argp[];
    struct sctstr sect;
    int	i, nsect, nseaspots, nrigs;
    struct shpstr ship;
    seaspot *ss;
    struct nstr_sect nstr;
    struct nstr_item ni;

    if (!snxtsct(&nstr, argp[1])) return RET_SYN;

    /*
    **  Cache a list of reportable ocean sectors
    */

    nseaspots = 0;

    snxtitem_all(&ni, EF_SHIP);
    for (nrigs=2; nxtitem(&ni, (char *)&ship); )
	if (mchr[ship.shp_type].m_flags & M_OIL) nrigs++;
    ss = (seaspot *) malloc(nrigs * sizeof(seaspot));

    if (ss) {
	snxtitem_all(&ni, EF_SHIP);
	while (nseaspots<nrigs && nxtitem(&ni, (char *)&ship)) {
	    if (mchr[ship.shp_type].m_flags & M_OIL) {
		for (i=0; i<nseaspots; i++)
		    if (ss[i].x==ship.shp_x && ss[i].y==ship.shp_y) 
			break; /* sector already cached */
		if (i==nseaspots) {
		    ss[nseaspots].x = ship.shp_x;
		    ss[nseaspots++].y = ship.shp_y;
		}
	    }
	}
    }

    prdate();
    for (nsect=0; nxtsct(&nstr, &sect); ) {

	if (sect.sct_type==SCT_WATER) {
	    for (i=0; i<nseaspots; i++)
		if (ss[i].x==sect.sct_x && ss[i].y==sect.sct_y) 
		    break;
	    if (i==nseaspots) continue;
	} else {
	    if (!owner) continue;
	}

	if (!nsect++) reso_hdr();
	if (god) pr(fmt("%3d ", sect.sct_own));
	pr(xyfmt("%4d,%-4d", nstr.x, nstr.y, cnum));
	pr(fmt(" %c", dchr[sect.sct_type].d_mnem));
	if (sect.sct_newtype != sect.sct_type)
	    pr(fmt("%c", dchr[sect.sct_newtype].d_mnem));
	else
	    pr(" ");
	pr(fmt("%4d%%", sect.sct_effic));
	pr(fmt(" %4d", sect.sct_min));
	pr(fmt("%5d", sect.sct_gmin));
	pr(fmt("%5d", sect.sct_fertil));
	pr(fmt("%4d", sect.sct_oil));
	pr(fmt("%5d", sect.sct_uran));
	/*		pr(fmt("%5d", sect.sct_elev));*/
	if (!god && sect.sct_terr > 0)
	    pr(fmt("%4d", sect.sct_terr));
	pr("\n");
    }
    pr(fmt("    %d sector%s\n", nsect, splur(nsect)));

    free(ss);
    return 0;
}

static reso_hdr()
{
    if (god) pr("    ");
    pr("RESOURCE\n");
    if (god) pr("own ");
    pr("  sect        eff  min gold fert oil uran ");
    if (!god) pr("ter");
    pr("\n");
}
