#ifndef lint
static char *RCSid = "$Header: sub.c,v 1.1 89/12/14 08:20:51 jay Exp $";
#endif /* not lint */

/*
**  sub.c
**
**  7/9/91 Bill Frolik
*/

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "sect.h"
#include "ship.h"
#include "nat.h"
#include "nsc.h"
#include "deity.h"
#include "loc.h"
#include "file.h"

sub()
{
    extern char *argp[];
    int	nships;
    struct nstr_item ni;
    struct shpstr ship;
    int	vec[I_MAX+1];
    
    if (argp[2] && *argp[2]) {
	return setdepth();
    }

    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    nships = 0;
    while (nxtitem(&ni, (char *)&ship)) {
	if (ship.shp_type < 0 || ship.shp_type > shp_maxno) {
	    pr(fmt("bad ship type %d (#%d)\n",ship.shp_type, ni.cur));
	    continue;
	}
	if (!owner || !ship.shp_own || !issub(&ship)) continue;
	if (nships++ == 0) {
	    if (god) pr("own ");
	    pr("sub#       type          x,y   ");
	    pr(" f/c  eff depth mil food gun she pet mob   air\n");
	    }
	getvec(VT_ITEM, vec, (char *)&ship, EF_SHIP);
	if (god) pr(fmt("%3d ", ship.shp_own));
	pr(fmt("%4d ", ni.cur));
	pr(fmt("%-16.16s ", mchr[ship.shp_type].m_name));
	pr(fmt("%s ", xyfmt("%4d,%-4d", ship.shp_x,ship.shp_y, cnum)));
	pr(fmt("%1c %1c", ship.shp_fleet,ship.shp_convoy));
	pr(fmt("%4d%% ", ship.shp_effic));
	switch (ship.shp_depth) {
	case 0: pr("surf"); break;
	case 1: pr("peri"); break;
	case 2: pr("deep"); break;
	default:pr("????");
	}
	pr(fmt("%5d", vec[I_MILIT]));
	pr(fmt("%5d", vec[I_FOOD]));
	pr(fmt("%4d", vec[I_GUN]));
	pr(fmt("%4d", vec[I_SHELL]));
	pr(fmt("%4d", vec[I_PETROL]));
	pr(fmt("%4d", ship.shp_mobil));
	pr(fmt("%6d\n", ship.shp_air));
    }
    if (nships == 0) {
	pr(fmt("%s: No subs\n", (argp[1]) ? argp[1] : ""));
	return RET_FAIL;
    }
    pr(fmt("%d sub%s\n",nships,splur(nships)));
    return RET_OK;
}

setdepth()
{
    extern	char *argp[];
    extern      int sub_hullair;
    struct	nstr_item ni,ns;
    struct	shpstr sub,ship;
    int		vec[I_MAX+1];
    int		itemvec[I_MAX+1];
    int		type;
    struct	sctstr sect;
    struct	mchrstr *mp;
    char	*p;
    int		i,dep,mcost,nships,numships;
    
    struct shipcache {
	natid own;
	int id;
	coord x,y;
    } *shplst;

    if (!snxtitem(&ni, EF_SHIP, argp[1])) return RET_SYN;
    p = getstarg(argp[2],"What depth (surface, periscope, or deep)? ");
    dep = -1;
    if (p) switch (*p) {
    case 's': dep = 0; break;
    case 'p': dep = 1; break;
    case 'd': dep = 2; break;
    }
    if (dep < 0) return RET_SYN;

    /* cache the global ship list so we can report sub surfacings */
    if (!snxtitem_all(&ns, EF_SHIP)) return RET_SYN;
    for (numships=2; nxtitem(&ns, (char *)&sub); numships++);
    shplst = malloc(numships*sizeof(struct shipcache));
    numships= 0;
    if (shplst) {
	snxtitem_all(&ns, EF_SHIP);
	while (nxtitem(&ns, (char *)&sub)) {
	    if (sub.shp_own && sub.shp_own!=cnum) {
		shplst[numships].own = sub.shp_own;
		shplst[numships].id = sub.shp_uid;
		shplst[numships].x = sub.shp_x;
		shplst[numships].y = sub.shp_y;
		numships++;
	    }
	}
    }
    
    for (nships=0; nxtitem(&ni, (char *)&sub);) {
	if (sub.shp_type < 0 || sub.shp_type > shp_maxno) {
	    pr(fmt("bad ship type %d (#%d)\n",sub.shp_type, ni.cur));
	    continue;
	}
	if (!owner || !sub.shp_own || !issub(&sub)) continue;
	mp = &mchr[sub.shp_type];
	pr(fmt("%s ",shipas(&sub,0)));
	getvec(VT_ITEM, vec, (char *)&sub, EF_SHIP);
	if (!vec[I_CIVIL] && !vec[I_MILIT]) {
	    pr("has no crew!\n");
	    continue;
	}
	if (sub.shp_mobil <= 0) {
	    pr("out of mobility.\n");
	    continue;
	}
	getsect(sub.shp_x, sub.shp_y, &sect);
	if (dep>0) {
	    if ((sect.sct_type==SCT_HARBR)
#ifdef TRADECENTERS
		|| (sect.sct_type==SCT_TRADE)
#endif
		) {
		pr("can't submerge in a harbor!\n");
		continue;
	    }
	}
	if (dep == sub.shp_depth) {
	    pr("no change, running ");
	    switch (dep) {
	    case 0: pr("on surface"); break;
	    case 1: pr("at periscope depth"); break;
	    case 2: pr("deep"); break;
	    }
	}
	else {
	    switch (dep) {
	    case 0: pr("surfacing"); break;
	    case 2: pr("diving deep"); break;
	    case 1: pr(fmt("%s to periscope depth",
			   (dep>sub.shp_depth) ? "submerging" : "rising"));
		break;
	    }

	    if (dep==0 || (sub.shp_depth==0 && dep>0)) {
		for (i=0; i<numships; i++) {
		    if (shplst[i].x==sub.shp_x && shplst[i].y==sub.shp_y) {
			getship(shplst[i].id,(char *)&ship);
			wu(0, ship.shp_own,
			   fmt("%s spotted %s %s in %s",
			       shipas(&ship,0), shipas(&sub,LO),
			       dep==0 ? "surfacing" : "submerging",
			       xyas(ship.shp_x,ship.shp_y,ship.shp_own)));
		    }
		}
	    }
		
	    sub.shp_depth = dep;
	    sub.shp_mobil--;
	    if (dep==0 && sub.shp_air<sub_hullair) sub.shp_air = sub_hullair;
	    putship(sub.shp_uid, (char *)&sub);
	}
	pr(fmt(" in %s.\n",xyas(sub.shp_x,sub.shp_y,cnum)));
	nships++;
    }
    if (nships == 0) {
	pr(fmt("%s: No subs\n", (argp[1]) ? argp[1] : ""));
	return RET_FAIL;
    }
    pr(fmt("%d sub%s\n",nships,splur(nships)));
    return RET_OK;
}
