#ifndef lint
static char *RCSid = "$Header: torp.c,v 1.1 89/12/14 08:21:05 jay Exp $";
#endif /* not lint */

/*
 * torp.c
 *
 * fire torpedoes at enemy shipping.
 *
 * from PSL Empire, 1985
 */

#include "misc.h"
#include "var.h"
#include "ship.h"
#include "file.h"
#include "xy.h"
#include "loc.h"
#include "nat.h"
#include "nsc.h"
#include "news.h"

torp()
{
    extern	char *argp[];
    natid	vshipown;
    int	range;
    int	dam;
    int	shells;
    int	subno;
    int	victno;
    int i;
    double	erange;
    double	hitchance;
    struct	nstr_item ni;
    struct	shpstr vship;
    struct	shpstr sub;
    struct	shpstr dd;
    char 	*ptr;
    
    if ((ptr = getstarg(argp[1], "Victim ship #? ")) == 0)
	return RET_SYN;
    if ((victno = atoi(ptr)) < 0)
	return RET_SYN;
    if (!getship(victno, &vship))
	return RET_FAIL;
    if (vehicleclass(&vship) != CLASS_SHIP) {
	pr("You can't torpedo that!\n");
	return RET_FAIL;
    }
    if ((ptr = getstarg(argp[2], "From sub #? ")) == 0)
	return RET_SYN;
    if ((subno = atoi(ptr)) < 0)
	return RET_SYN;
    if (!getship(subno, &sub))
	return RET_FAIL;
    if (sub.shp_own != cnum) {
	pr("Not your sub!\n");
	return RET_FAIL;
    }
    if (victno == subno) {
	pr("Shooting yourself, eh?  How strange...\n");
	return RET_FAIL;
    }
    if (!(mchr[sub.shp_type].m_flags & M_TORP)) {
	pr(fmt("A %s can't fire torpedoes!\n",
	       mchr[sub.shp_type].m_name));
	return RET_FAIL;
    }
    shells = getvar(V_SHELL, (char *)&sub, EF_SHIP);
    if (!getvar(V_GUN, (char *)&sub, EF_SHIP) || (shells<3)) {
	pr("Insufficient armament.\n");
	return RET_FAIL;
    }
    if (sub.shp_effic < 60) {
	pr("Torpedo tubes inoperative.\n");
	return RET_FAIL;
    }
    if (sub.shp_mobil <= 0) {
	pr("Insufficient mobility\n");
	return RET_FAIL;
    }
    erange = sub.shp_effic * techfact(sub.shp_tech, 2.0) / 100.0;
    pr(fmt("Effective torpedo range is %.1f\n", erange));
    putvar(V_SHELL, shells - 3, (char *)&sub, EF_SHIP);
    sub.shp_mobil -= 20;
    pr("Whooosh... ");
    getship(victno, &vship);
    vshipown = vship.shp_own;
    if (!vshipown) {
	if (sub.shp_depth<2)
	    pr(fmt("We see no target %s #%d, Captain.",
		   class[vehicleclass(&vship)].name,victno));
	else
	    pr("Doesn't seem to be anything out there, Captain.");
	return RET_FAIL;
    }
    range = mapdist(sub.shp_x, sub.shp_y, vship.shp_x, vship.shp_y);
    hitchance = 0.90 / (range + 1);
    if (sub.shp_depth > 1) 
	hitchance *= 0.35; /* deep subs have poor aim */
    switch (vship.shp_depth) {
    case 1: hitchance *= 0.85; break; /* periscope depth target */
    case 2: hitchance *= 0.35; break; /* deep target */
    }
    if (range > erange) {
	pr("Out of range\n");
    } else if (chance(hitchance)) {
	
	/*
	**  If victim ship tech is high enough, it is able
	**  to identify the attacking ship (but not its owner).
	*/

	pr("BOOM!...\n");

	if (vship.shp_tech>50 && 
	    ((sub.shp_depth==0) || (sub.shp_depth==1 && chance(0.5))))
	    wu(0,vshipown,
	       fmt("%s hit by a torpedo from %s",
		   shipasc(&vship,LS,vshipown),
		   shipasc(&sub,LOS,vshipown)));
	else
	    wu(0,vshipown,
	       fmt("%s hit by a torpedo",shipasc(&vship,LS,vshipown)));
	
	dam = 50 + (random() % 50);
	dam = (100 * dam) / (mchr[vship.shp_type].m_armor + 50);
	shipdamage(&vship, dam);
	putship(victno, &vship);
	nreport(vshipown, N_TORP_SHIP, 0, 1);

    } else {

	    pr("Missed\n");
	    wu(0, vshipown,
	       fmt("Torpedo %s by %s",
		   vship.shp_depth==0 ? "sighted" : "heard",
		   shipasc(&vship,LOS,vshipown)));
	    
	}

    snxtitem_dist(&ni, EF_SHIP, sub.shp_x, sub.shp_y, 0);
    while (nxtitem(&ni, (char *)&dd) && sub.shp_effic >= 20) {
	if (dd.shp_own != vshipown) continue;
	if (!(mchr[dd.shp_type].m_flags & M_DCH)) continue;
	if (dd.shp_x != sub.shp_x) continue;
	if (dd.shp_y != sub.shp_y) continue;
	i = 0;
    again:
	if (getvar(V_GUN, (char *)&dd, EF_SHIP) < 1) continue;
	shells = getvar(V_SHELL, (char *)&dd, EF_SHIP);
	if (shells < 2) continue;
	if (!i++) {
	    pr("\nCAPTAIN!  Depth charges!!!...\n");
	    wu(0, vshipown,
	       fmt("%s #%d dropped depth charges on sub #%d",
		   mchr[dd.shp_type].m_name,ni.cur, subno));
	}
	putvar(V_SHELL, shells - 2, (char *)&dd, EF_SHIP);
	putship(ni.cur, &dd);
	dam = (random() % 70) + 10;
	pr("click... ");
	if (dam>60) pr(">>!! K A B L A M !!<<"); else
	if (dam>40) pr(">> !WHAM! <<");
	if (dam>20) pr(">!boom!<"); else
	pr(">fwoom<");
	pr(fmt("  %d%% damage!\n", dam));
	shipdamage(&sub, dam);
	if (chance(0.1)) goto again;
    }
    putship(subno, &sub);
    return RET_OK;
}
