static char *RCSid = "$Header: list.c,v 1.1 89/12/14 13:28:20 jay Exp $";

/*
 * list.c
 *
 * list ships, planes at a given x,y.
 *
 * Dave Pare, 1986
 */

#include "misc.h"
#include "var.h"
#include "news.h"
#include "class.h"
#include "ship.h"
#include "sect.h"
#include "nuke.h"
#include "plane.h"
#include "nat.h"
#include "item.h"
#include "xy.h"
#include "nsc.h"
#include "file.h"

int bombableshipsatxy( x, y, wantflags, nowantflags)
coord x,y;
int wantflags,nowantflags;
{ 
    return vatxy(x,y,wantflags,nowantflags,vcmask(CLASS_SHIP,-1,-1,-1),1);
}

int shipsatxy(x, y, wantflags, nowantflags)
coord x,y;
int wantflags,nowantflags;
{ 
    return vatxy(x,y,wantflags,nowantflags,vcmask(CLASS_SHIP,-1,-1,-1),0);
}

int tanksatxy(x, y, wantflags, nowantflags)
coord x,y;
int wantflags,nowantflags;
{ 
    return vatxy(x,y,wantflags,nowantflags,vcmask(CLASS_TANK,-1,-1,-1),0);
}

int balloonsatxy(x, y, wantflags, nowantflags)
coord x,y;
int wantflags,nowantflags;
{ 
    return vatxy(x,y,wantflags,nowantflags,vcmask(CLASS_BALLOON,-1,-1,-1),0);
}

int trainsatxy(x, y, wantflags, nowantflags)
coord x,y;
int wantflags,nowantflags;
{ 
    return vatxy(x,y,wantflags,nowantflags,vcmask(CLASS_TRAIN,-1,-1,-1),0);
}

/* ________________________________________________________________
**|                                                                |
**| vatxy - Vehicles At X,Y                                        |
**|________________________________________________________________|
*/

int vatxy(x, y, wantflags, nowantflags, vcb, skipalofts)
coord x,y;
int vcb,wantflags,nowantflags,skipalofts;
{
    extern char *effadv();
    int	vc,first,ships;
    struct nstr_item ni;
    struct mchrstr *mp;
    struct shpstr ship;

    first = 1;
    ships = 0;
    snxtitem_xy(&ni, EF_SHIP, x, y);
    while (nxtitem(&ni, (char *)&ship)) {
	if (ship.shp_effic < 20 || ship.shp_own == 0) continue;
	if (ship.shp_aboard >= 0) continue;
	vc = 1 << mchr[ship.shp_type].m_class;
	if (vcb && ((vc & vcb)==0)) continue;
	if (skipalofts && isballoon(&ship) && ship.shp_depth>1)
	    continue;
	mp = &mchr[ship.shp_type];
	if (wantflags) {
	    if ((mp->m_flags & wantflags) == 0)	continue;
	}
	if (nowantflags) {
	    if (mp->m_flags & nowantflags & M_SUB) {
		if (issub(&ship) && ship.shp_depth>0) continue;
	    }
	    else if (mp->m_flags & nowantflags)
		continue;
	}
	/* 
	 **  Subs are slimey critters.
	 */
	if (issub(&ship) && ship.shp_own!=cnum && ship.shp_depth>0) {
	    if (chance(0.1)) continue;
	    if (ship.shp_depth>1 && chance(0.5)) continue;
	}
	if (first) {
	    pr(" #          owner           eff        type\n");
	    first = 0;
	}
	pr(fmt("(#%3d) %10.10s  %12.12s  %s\n", ni.cur,
	       cname(ship.shp_own),
	       effadv(ship.shp_effic), mp->m_name));
	ships++;
    }
    return ships;
}

int
planesatxy(x, y, wantflags, nowantflags)
	coord	x;
	coord	y;
	int	wantflags;
	int	nowantflags;
{
	int	first;
	int	planes;
	struct	plnstr plane;
	struct	nstr_item ni;
	struct	plchrstr *plp;

	planes = 0;
	first = 1;
	snxtitem_xy(&ni, EF_PLANE, x, y);
	while (nxtitem(&ni, (char *)&plane)) {
		if (plane.pln_effic < 10 || plane.pln_own == 0)
			continue;
		if (plane.pln_flags & (PLN_LAUNCHED|PLN_BOXED))
			continue;
		plp = &plchr[plane.pln_type];
		if (first) {
			pr(" #          owner        eff       type\n");
			first = 0;
		}
		if (wantflags) {
			if ((plp->pl_flags & wantflags) == 0)
				continue;
		}
		if (nowantflags) {
			if (plp->pl_flags & nowantflags)
				continue;
		}
		pr(fmt("(#%3d) %10.10s  %12.12s  %s\n", ni.cur,
			cname(plane.pln_own),
			effadv(plane.pln_effic), plp->pl_name));
		planes++;
	}
	return planes;
}
