#ifndef lint
static char *RCSid = "$Header: nxtitem.c,v 1.1 89/12/14 13:28:26 jay Exp $";
#endif

/*
 * nxtitem.c
 *
 * get next item from list.
 *
 * Dave Pare, 1989
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "plane.h"
#include "ship.h"
#include "nuke.h"
#include "nsc.h"
#include "nat.h"
#include "file.h"

/*
 * XXX cheap hack; this depends on the fact
 * that units are all the same starting from the top.
 */
struct genitem {
	coord	x;
	coord	y;
	natid	own;
	char	type;
	char	effic;
	char	mobil;
	short	sell;
	short	tech;
	short	uid;
	char	group;
	char	name[NS_NSIZE];
};

int nxtitem(np, ptr)
struct nstr_item *np;
caddr_t	ptr;
{
    struct	genitem *gp;
    int	selected;
    
    if (np->sel == NS_UNDEF) return 0;
    gp = (struct genitem *) ptr;
    do {
	if (np->sel == NS_LIST) {
	    np->index++;
	    if (np->index >= np->size) return 0;
	    np->cur = np->list[np->index];
	} else {
	    np->cur++;
	}
	if (!np->read(np->type, np->cur, ptr)) {
	    /* if read fails, fatal */
	    return 0;
	}
	selected = 1;
	switch (np->sel) {
	case NS_LIST:
	    if ((np->flags & EFF_OWNER) && !owner)
		selected = 0;
	    break;
	case NS_ALL:
	    /* XXX maybe combine NS_LIST and NS_ALL later */
	    break;
	case NS_DIST:
	    gp->x = xnorm(gp->x);
	    gp->y = ynorm(gp->y);
	    if (!xyinrange(gp->x, gp->y, &np->range))
		selected = 0;
	    else {
		np->cx = xnorm(np->cx);
		np->cy = ynorm(np->cy);
		np->curdist = mapdist((int)gp->x, (int)gp->y,
				      (int)np->cx, (int)np->cy);
		if (np->curdist > np->dist) selected = 0;
	    }
	    break;
	case NS_AREA:
	    gp->x = xnorm(gp->x);
	    gp->y = ynorm(gp->y);
	    if (!xyinrange(gp->x, gp->y, &np->range))
		selected = 0;
	    if (gp->x == np->range.hx || gp->y == np->range.hy)
		selected = 0;
	    break;
	case NS_XY:
	    gp->x = xnorm(gp->x);
	    gp->y = ynorm(gp->y);
	    np->cx = xnorm(np->cx);
	    np->cy = ynorm(np->cy);
	    if ((gp->x != np->cx) || (gp->y != np->cy))
		selected = 0;
	    break;
	case NS_GROUP:
	    if (np->group != gp->group)
		selected = 0;
	    break;
	case NS_NAME:
	    if (!patmat(gp->name,np->name,0))
		selected = 0;
	    break;
	default:
	    dpr(fmt("nxtitem: bad selector %d\n", np->sel)); 
	    logerror("nxtitem: bad selector %d\n", np->sel);
	    return 0;
	}
	if (selected && np->ncond) {
	    /* nstr_exec is expensive, so we do it last */
	    dpr(fmt("nxtitem: np->ncond=%d",np->ncond));
	    if (!nstr_exec(np->cond, np->ncond, ptr, np->type))
		selected = 0;
	}
	if (selected) dpr(fmt("nxtitem: item %d selected",np->cur));
    } while (!selected);
    return 1;
}
