#ifndef lint
static char *RCSid = "$Header: ship.c,v 1.1 89/12/14 13:28:37 jay Exp $";
#endif

/*
 * ship.c
 *
 * ship pre-write data massage
 *
 * Dave Pare, 1989
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "nat.h"
#include "sect.h"
#include "ship.h"
#include "nsc.h"
#include "deity.h"
#include "file.h"

char *STB(flg)
int flg;
{
    static char STBbuf[40];
    strcpy(STBbuf,flg&1 ? "Ship" : "ship");
    if (flg&2) strcat(STBbuf,"s");
#ifdef TANKS
    strcat(STBbuf,flg&1 ? "/Tank" : "/tank");
    if (flg&2) strcat(STBbuf,"s");
#endif
#ifdef BALLOONS
    strcat(STBbuf,flg&1 ? "/Balloon" : "/balloon");
    if (flg&2) strcat(STBbuf,"s");
#endif    
#ifdef TRAINS
    strcat(STBbuf,flg&1 ? "/Train" : "/train");
    if (flg&2) strcat(STBbuf,"s");
#endif
    return((char *)STBbuf);
}

/*ARGSUSED*/
shp_postread(n, ptr)
int n;
char *ptr;
{
    struct shpstr *sp = (struct shpstr *)ptr;
    owner = (god || sp->shp_own == cnum);
    return 1;
}

int
shp_prewrite(n, ptr)
short n;
char *ptr;
{
    struct shpstr vehicle,saveship;
    struct nstr_item nstr;
    struct shpstr *sp = (struct shpstr *) ptr;
    struct sctstr sect;
    short crew,oldowner;
    char *p;

    if ((sp->shp_effic < 20) || sp->shp_own==0) {
	if (sp->shp_own==cnum || sp->shp_aboard<0) {
	    pr(isship(sp)
	       ? ( sp->shp_depth==0
		  ? fmt("%s #%d sunk!\n",
			mchr[sp->shp_type].m_name,n)
		  : fmt("%s #%d debris spotted!\n",
			mchr[sp->shp_type].m_name,n) )
	       : fmt("%s #%d destroyed!\n", 
		     mchr[sp->shp_type].m_name, n));
	}
	if (sp->shp_own && sp->shp_own!=cnum) {
	    wu(0, sp->shp_own, isship(sp)
	       ? fmt("%s #%d sunk!\n",mchr[sp->shp_type].m_name,n)
	       : fmt("%s #%d destroyed!\n", mchr[sp->shp_type].m_name, n));
	}
	sp->shp_own = 0;

	/*
	**  If this routine is sinking a ship that can be used
	**  to transport other vehicles ...
	**  Walk through the ship list looking for vehicles that
	**  need to go down with this ship.  If this works okay,
	**  this routine should recurse.
	*/

	if (isship(sp) && (mchr[sp->shp_type].m_maxtnks)) {
	    snxtitem_all(&nstr, EF_SHIP);
	    while (nxtitem(&nstr, (char *)&vehicle))
		if (!isship(&vehicle) && vehicle.shp_own && 
		    (vehicle.shp_aboard == n)) {
		    vehicle.shp_effic = 0;
		    putship(nstr.cur,&vehicle);
		}
	    seekship(n);
	}

    } else {
	
	/*
	**  If this routine is writing a tank ...
	**  Check if this is an unmanned vehicle and, if it is,
	**  change ownership to the owner of the transport ship
	**  or current sector.
	*/

	if (istank(sp)) {
	    crew = getvar(V_MILIT, (char *)sp, EF_SHIP)
		+ getvar(V_CIVIL, (char *)sp, EF_SHIP);
	    oldowner = sp->shp_own;

	    /* If vehicle has no crew ... */
	    if (!crew) {
		if (sp->shp_aboard >= 0) {
		    /* ... and is aboard a transport ... */
		    if (getship(sp->shp_aboard,&vehicle)) {
			if (vehicle.shp_own != sp->shp_own) {
			    sp->shp_own = vehicle.shp_own;
			}
		    }
		    seekship(n); /* that getship() clobbered our position */
		} else if (getsect(sp->shp_x, sp->shp_y, &sect)) {
		    /* ... or is in an owned sector ... */
		    if (sect.sct_own) {
			sp->shp_own = sect.sct_own;
		    }
		}
	    }

	    if (oldowner != sp->shp_own) {

		/* Inform the old owner of his loss */
		prc(oldowner,
		    fmt("Crewless %s #%d claimed by %s in %s\n",
			mchr[sp->shp_type].m_name,n,cname(sp->shp_own),
			xyas(sp->shp_x,sp->shp_y,oldowner)));

		/* Inform the new owner of his acquisition */
		prc(sp->shp_own,
		    fmt("Crewless %s %s #%d captured in %s\n",
			cname(oldowner),mchr[sp->shp_type].m_name,n,
			xyas(sp->shp_x,sp->shp_y,sp->shp_own)));
	    }
	}
	
	/*
	**  If this routine is writing a ship ...
	**  Walk through the ship list looking for vehicles that
	**  need to move along with this ship.  If this works okay,
	**  this routine should recurse.
	*/

	if (isship(sp)) {
	    dpr(fmt("updating vehicles aboard ship %d (%d)",n,sp->shp_uid));
	    snxtitem_all(&nstr, EF_SHIP);
	    while (nxtitem(&nstr, (char *)&vehicle)) {
		if (istank(&vehicle)) {
		    if (vehicle.shp_own && (vehicle.shp_aboard == n)) {
			vehicle.shp_x = sp->shp_x;
			vehicle.shp_y = sp->shp_y;
			dpr(fmt("  vehicle %d (%d) moved to %d,%d",
			       nstr.cur,vehicle.shp_uid,sp->shp_x,sp->shp_y));
			putship(nstr.cur,&vehicle);
		    }
		}
	    }
	    
	    dpr(fmt("  reseeking ship %d",n));
	    seekship(n);
	}
    }
    return 1;
}
